"use strict";

jQuery(function($) {
  $(document).ready(function() {
    var wrapper = $(".tree");
    var parentIDs = ($('#parentIDsInput').val()) ? $('#parentIDsInput').val().split(',') : [];
    $('.update-nag, .updated, .is-dismissible, .notice, .notice-info, .error, .settings-error').remove();
    $(window).on('load', function(e) {
      if (window.location.href.indexOf("page=smwpcb_wp_chatbot_topics&action=edit&topic") > -1) {
          window.onbeforeunload = function() {
              return "Data will be lost if you leave the page, are you sure?";
          };
      }
      wrapper.find('.togglePanel').each(function() {
        var k = 0;
        var elmtID = '';
        $(this).find('input[type="radio"]').each(function() {
          if ($(this).is(':checked')) {
              elmtID = $(this).attr('name');
              return false;
          }
          k++;
        });
        var toggleclass = '';
        if ($(this).attr('style') == "display:none")
          toggleclass = '<div class="smwpcb_margin_left togglePanel" style="display:none">';
        else
          toggleclass = '<div class="smwpcb_margin_left togglePanel" style="display:block">';
        $(this).replaceWith(
          toggleclass + `
            <div class="panel panel-default" aria-describedby="helpBlock2">
              <div class="panel-heading" style="text-align: center;">Available Columns</div>
                <table class="table"> 
                 <thead> 
                  <tr> 
                    <th>Check</th> 
                    <th>Column Name</th> 
                    <th>Variable Name</th> 
                  </tr> 
                 </thead> 
                 <tbody>
               ` +
                    smwpcb_displayDataColumns(smwpcb_data_tables_settings, elmtID, k) 
                 +
                  ` 
                </tbody>
                </table>
              </div>
            <span class="help-block">These data columns can be manually set in the previous options, you can use the chosen @variable-name on the next message bubbles.</span>
            </div>`);
      });
      wrapper.find('.terdestToggle').each(function() {
        if ($(this).attr('style') == "display:block") {
          var selectTopic = '';
          if ($(this).find('input').length) {
              $(this).find('input').each(function() {
                  if ($(this).is(':checked')) {
                      selectTopic = $(this).val();
                      return false;
                  }
              });
          }
          selectTopic = ((selectTopic == '') ? 'first' : selectTopic);
          var selectopt = $(this).find('select').val();
          var selectElmID = $(this).find('select').attr('element-id');
          var stringTpc = `
          <div class="toggleTopics" style="display:block"><div class="panel panel-default" aria-describedby="helpBlock2">
            <div class="panel-heading" style="text-align: center;vertical-align: middle;">Available Blocks</div>
            <div class="panel-heading" style="text-align: center;vertical-align: middle;"><i class="fas fa-redo-alt smwpcb_refresh_topics" element-id="` + selectElmID + `" style="font-size: 15px;cursor:pointer;"></i></div>
            <table class="table"> 
            <thead> 
              <tr> 
                <th>Check</th> 
                <th>First Response</th>
                <th style="text-align: center;vertical-align: middle;">Expend</th>
              </tr> 
            </thead> 
            <tbody>
            </tbody>
            </table>
            </div>
          </div> <!-- toggleTopics -->`;
          var stringclosedTpc = '<div class="toggleTopics" style="display:none"></div>';
          $(this).replaceWith(
              `<div class="smwpcb_margin_left terdestToggle" style="display:block">
                  <div class="form-group">
                    <label class="smwpcb_label_bottom">Please choose how you want to close discussion</label>
                    ` + smwpcb_display_destination_topic(selectopt, $(this).closest('.infom').attr('element-id')) + `
                  </div>
                  ` + ((selectopt !== 'closeDisc') ? stringTpc : stringclosedTpc) + `
                </div>`);
          smwpcb_display_topics_first_msg(selectopt, selectElmID, selectTopic);
        }
      });
      smwpcb_solve_verticaltab();
      smwpcb_change_unsetted_triggers_div();
      smwpcb_solve_keywords_tags_suggest();
      smwpcb_reduce_all_panels();
      //smwpcb_remove_back_slashes();
      smwpcb_solve_resort_options();
      $('.modal').attr('style', 'display:none');
      $('.wrap').attr('style', 'display:block');
    }); // window load

    wrapper.on("click", "li[aria-controls='tab_item-4'],li[aria-controls='tab_item-3']", function() {
      $(this).removeClass("blueBackfornotification");
      $(this).closest('.panelcb').find('.chatbotTools').removeClass("blueBackfornotification");
      var found = '0';
      if (wrapper.find('.blueBackfornotification').length != 0) {
          found = '1';
      }
      var data = {
          'action': 'smwpcb_remove_unsetted_triggers_db',
          'data_added': [$(this).closest('.infom').attr('element-id'), found, $('#smwpcb_topic_id_input').val()]
      };
      jQuery.post(smwpcb_custom_ui_topics_link.ajax_url, data);
    });

    wrapper.on("change", "input", function() {
        $(this).attr('value', smwpcb_sanitize_text_field($(this).val()));
    });

    wrapper.on("change", "textarea", function() {
        $(this).text(smwpcb_sanitize_text_field($(this).val()));
    });

    wrapper.on('click', '.gotosubtopic', function(e) {
      if ($(this).closest('.smwpcb_switch_radio').find('.typeTrigger').val() == 3 || $(this).closest('.smwpcb_switch_radio').find('.typeTrigger').val() == 1) {
          if ($(this).closest('.smwpcb_switch_radio').find('.faqoptionsdisplay').val().substr($(this).closest('.smwpcb_switch_radio').find('.faqoptionsdisplay').val().length - 5) == '|6^9~') {
            alert('The block that you choose is not complete, make sure you set the quick reply buttons on its children, then reload by clicking the reload button.');
            $(this).prop('checked', false);
            e.preventDefault();
          }
      }
    });

    wrapper.on('click', '#addresponse', function(e) {
      e.preventDefault();
      $(this).parent().find('.responsescontainer').append('<div class="new_message" style="display: table; width:100%;"><div class="smwpcb_message_unit"><textarea class="botresponse form-control smwpcb_bubble_message" placeholder="Message bubble"  rows="3" ></textarea></div><img title="delete message" class="delete_message" src="' + smwpcb_custom_ui_topics_link.image_path + '/delete.png"></div>');
    });

    wrapper.on('click', '#storeusrmessagefaq', function() {
      if ($(this).is(':checked'))
          $(this).closest('.contact-form1').find('.messagefaqToggle').attr('style', 'display:block');
      else
          $(this).closest('.contact-form1').find('.messagefaqToggle').attr('style', 'display:none');
    });

    wrapper.on('click', '#storeusrmessage', function() {
      if ($(this).is(':checked'))
          $(this).closest('.contact-form1').find('.messagevarToggle').attr('style', 'display:block');
      else
          $(this).closest('.contact-form1').find('.messagevarToggle').attr('style', 'display:none');
    });

    wrapper.on('click', '.delete_message', function() {
      $(this).closest('.new_message').remove();
    });

    wrapper.on("change", ".closedDiscussion", function() {
      var previous = $(this).find("option:selected");
      var preVal = previous.attr('value');
      var prevTopic = '';
      $(this).find('input').each(function() {
        if ($(this).is(':checked')) {
            prevTopic = $(this).val();
            return false;
        }
      });
      prevTopic = ((prevTopic == '') ? 'first' : prevTopic);
      $(this).find("option").each(function() {
          $(this).removeAttr('selected');
      });
      $(this).val(previous.val());
      previous.attr('selected', 'selected');
      if (preVal !== 'closeDisc') {
          $(this).closest('.contact-form1').find('.toggleTopics').replaceWith(
           ` 
            <div class="toggleTopics" style="display:block">
              <div class="panel panel-default" aria-describedby="helpBlock2">
              <div class="panel-heading" style="text-align: center;vertical-align: middle;">Available Blocks</div>
              <div class="panel-heading" style="text-align: center;vertical-align: middle;"><i class="fas fa-redo-alt smwpcb_refresh_topics" element-id="` + $(this).attr('element-id') + `" style="font-size: 15px;cursor:pointer;"></i></div>
              <table class="table"> 
              <thead> 
                <tr> 
                  <th>Check</th> 
                  <th>First Response</th>
                  <th style="text-align: center;vertical-align: middle;">Expend</th>
                </tr> 
              </thead> 
              <tbody> 
              <tr id="smwpcb_spin"> 
                <td colspan="3" style="text-align: center;vertical-align: middle;">loading..</span></td>
              </tr> 
              </tbody>
              </table>
              </div>
            </div> <!-- toggleTopics -->
          `);
          smwpcb_display_topics_first_msg(preVal, $(this).attr('element-id'), prevTopic);
      } else {
          $(this).closest('.contact-form1').find('.toggleTopics').replaceWith('<div class="toggleTopics" style="display:none"></div>');
      }
    });

    wrapper.on('click', '.smwpcb_refresh_topics', function() {
        $(this).closest('.contact-form1').find('.toggleTopics tbody').replaceWith('<tbody><tr id="smwpcb_spin"><td colspan="3" style="text-align: center;vertical-align: middle;">loading..</td></tr></tbody>');
        smwpcb_display_topics_first_msg($(this).closest('.contact-form1').find("option:selected").attr('value'), $(this).attr('element-id'), 'first');
    });

    wrapper.on('click', '#addproduct', function() {
      $(this).parent().find('.addPrdiv').append(`
        <div class="prodiv">
          <div class="underprodiv">
            <div class="form-group">
                  <label>Image Url</label>
                  <input type="url" class="form-control borderbottombluecolorred imageurl" placeholder="http://" autocomplete="off">
              </div>
              <div class="form-group">
                  <label>Link</label>
                  <input type="url" class="form-control borderbottombluecolorred linktocap" placeholder="http://" autocomplete="off">
              </div>
              <div class="form-group">
                  <label>Title</label>
                  <input type="text" class="form-control borderbottombluecolorred titlecap" placeholder="please enter a title" autocomplete="off">
              </div>
              <div class="form-group">
                  <label>Description</label>
                  <textarea rows="3" class="form-control borderbottombluecolorred descriptioncap" placeholder="please enter a description"></textarea>
              </div>
              <div class="form-group">
                  <label>Text button</label>
                  <input type="text" class="form-control borderbottombluecolorred caption" placeholder="please enter a text button" autocomplete="off">
              </div>
          </div>
          <img class="delete_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/delete.png">
        </div>`);
    });

    wrapper.on('click', '.delete_product', function() {
        $(this).parent().remove();
    });

    wrapper.on('click', '#addimage', function() {
        $(this).parent().find('.addimagediv').append(`
    <div class="imagediv">
      <div class="underprodiv">
        <div class="form-group">
          <label>Image Url</label>
          <input type="text" class="form-control borderbottombluecolorred imagedisplayurl" placeholder="https://" autocomplete="off">
        </div>
      </div>
      <img class="delete_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/delete.png">
    </div>`);
    });

    wrapper.on('click', '#addvideo', function() {
        $(this).parent().find('.addvideodiv').append(`
    <div class="videodiv">
      <div class="underprodiv">
        <div class="form-group">
          <label>Video Url</label>
          <input type="text" class="form-control borderbottombluecolorred videodisplayurl" placeholder="https://" autocomplete="off">
        </div>
      </div>
      <img class="delete_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/delete.png">
    </div>`);
    });

    wrapper.on('click', 'input[name^="resort"]', function() {
      var toggleclass = $(this).closest('.contact-form1').find('.togglePanel');
      var dresToggle = $(this).closest('.contact-form1').find('.dresToggle');
      var terdestToggle = $(this).closest('.contact-form1').find('.terdestToggle');
      var faqToggle = $(this).closest('.contact-form1').find('.togglefaq');
      var storeusrmessage = $(this).closest('.contact-form1').find('#storeusrmessage');
      var storeusrmessagefaq = $(this).closest('.contact-form1').find('#storeusrmessagefaq');

      var usedefautrescheck = $(this).closest('.contact-form1').find('#usedefautrescheck');
      var restorevarscheck = $(this).closest('.contact-form1').find('#restorevarscheck');
      var usefaqoptionscheck = $(this).closest('.contact-form1').find('#usefaqoptionscheck');
      var terminateTopicDest = $(this).closest('.contact-form1').find('#terminateTopicDest');

      if ($(this).is(':checked') && $(this).attr("id") == "restorevarscheck") {
          toggleclass.attr('style', 'display:block');
          dresToggle.attr('style', 'display:none');
          terdestToggle.attr('style', 'display:none');
          faqToggle.attr('style', 'display:none');
          storeusrmessage.prop('checked', false);
          $(this).closest('.contact-form1').find('.messagevarToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('.messagefaqToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('#resort_value').val("2");

          restorevarscheck.prop('checked', true);
          restorevarscheck.attr('checked', 'checked');
          usedefautrescheck.prop('checked', false);
          usedefautrescheck.removeAttr('checked');
          usefaqoptionscheck.prop('checked', false);
          usefaqoptionscheck.removeAttr('checked');
          terminateTopicDest.prop('checked', false);
          terminateTopicDest.removeAttr('checked');


      } else if ($(this).is(':checked') && $(this).attr("id") == "usedefautrescheck") {
          toggleclass.attr('style', 'display:none');
          dresToggle.attr('style', 'display:block');
          terdestToggle.attr('style', 'display:none');
          faqToggle.attr('style', 'display:none');
          $(this).closest('.contact-form1').find('.messagefaqToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('#resort_value').val("1");

          usedefautrescheck.prop('checked', true);
          usedefautrescheck.attr('checked', 'checked');
          restorevarscheck.prop('checked', false);
          restorevarscheck.removeAttr('checked');
          usefaqoptionscheck.prop('checked', false);
          usefaqoptionscheck.removeAttr('checked');
          terminateTopicDest.prop('checked', false);
          terminateTopicDest.removeAttr('checked');




      } else if ($(this).is(':checked') && $(this).attr("id") == "usefaqoptionscheck") {
          toggleclass.attr('style', 'display:none');
          dresToggle.attr('style', 'display:none');
          terdestToggle.attr('style', 'display:none');
          faqToggle.attr('style', 'display:block');
          $(this).closest('.contact-form1').find('.messagevarToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('#resort_value').val("3");

          usefaqoptionscheck.prop('checked', true);
          usefaqoptionscheck.attr('checked', 'checked');
          restorevarscheck.prop('checked', false);
          restorevarscheck.removeAttr('checked');
          usedefautrescheck.prop('checked', false);
          usedefautrescheck.removeAttr('checked');
          terminateTopicDest.prop('checked', false);
          terminateTopicDest.removeAttr('checked');


      } else {
          toggleclass.attr('style', 'display:none');
          dresToggle.attr('style', 'display:none');
          terdestToggle.attr('style', 'display:block');
          faqToggle.attr('style', 'display:none');
          $(this).closest('.contact-form1').find('.messagevarToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('.messagefaqToggle').attr('style', 'display:none');
          $(this).closest('.contact-form1').find('#resort_value').val("4");

          terminateTopicDest.prop('checked', true);
          terminateTopicDest.attr('checked', 'checked');
          restorevarscheck.prop('checked', false);
          restorevarscheck.removeAttr('checked');
          usedefautrescheck.prop('checked', false);
          usedefautrescheck.removeAttr('checked');
          usefaqoptionscheck.prop('checked', false);
          usefaqoptionscheck.removeAttr('checked');

      }
    });

    wrapper.on('click', 'input#displayprod', function() {
      var toggleclass = $(this).closest('.contact-form1').find('.toggleProduct');
      if ($(this).is(':checked'))
          toggleclass.attr('style', 'display:block');
      else
          toggleclass.attr('style', 'display:none');
    });

    wrapper.on('click', 'input#imageCheck', function() {
      var toggleclass = $(this).closest('.contact-form1').find('.toggleImage');
      if ($(this).is(':checked'))
          toggleclass.attr('style', 'display:block');
      else
          toggleclass.attr('style', 'display:none');
    });

    wrapper.on('click', 'input#videoCheck', function() {
      var toggleclass = $(this).closest('.contact-form1').find('.toggleVideo');
      if ($(this).is(':checked'))
          toggleclass.attr('style', 'display:block');
      else
          toggleclass.attr('style', 'display:none');
    });

    wrapper.on('click', 'input#googlesrch', function() {
      if (smwpcb_chatbots_general_settings['smwpcb_google_custom_search_api_key'] != "" && smwpcb_chatbots_general_settings['smwpcb_google_custom_search_api_key'] != null) {
          var toggleclass = $(this).closest('.contact-form1').find('.toggleGoogleSrch');
          if ($(this).is(':checked'))
              toggleclass.attr('style', 'display:block');
          else
              toggleclass.attr('style', 'display:none');
      } else {
          $(this).prop('checked', false);
      }

    });

    wrapper.on('click', 'input#specificquery', function() {
      var toggleclass1 = $(this).closest('.contact-form1').find('.togglespecificsearch');
      var toggleclass2 = $(this).closest('.contact-form1').find('.toggleusersearch');
      if ($(this).is(':checked')) {
          toggleclass1.attr('style', 'display:block');
          toggleclass2.attr('style', 'display:none');
      } else {
          toggleclass1.attr('style', 'display:none');
          toggleclass2.attr('style', 'display:block');
      }
    });

    wrapper.on('click', 'input#usersquery', function() {
      var toggleclass1 = $(this).closest('.contact-form1').find('.toggleusersearch');
      var toggleclass2 = $(this).closest('.contact-form1').find('.togglespecificsearch');
      if ($(this).is(':checked')) {
          toggleclass1.attr('style', 'display:block');
          toggleclass2.attr('style', 'display:none');
      } else {
          toggleclass1.attr('style', 'display:none');
          toggleclass2.attr('style', 'display:block');
      }
    });

    wrapper.on('click', 'input[type="checkbox"]', function() {
      var attr = $(this).attr('checked');
      if (typeof attr !== typeof undefined && attr !== false) {
          $(this).removeAttr('checked');
          $(this).prop('checked', false);
      } else {
          $(this).attr('checked', 'checked');
          $(this).prop('checked', true);
          
      }
    });


   /* wrapper.on('click', 'input[type="checkbox"], input[type="radio"]', function() {
      var attr = $(this).attr('checked');
      if (typeof attr !== typeof undefined && attr !== false) {
          
          $(this).attr('checked', 'checked');
          $(this).prop('checked', true);
      } else {
          $(this).removeAttr('checked');
          $(this).prop('checked', false);
          
      }
    });*/




    wrapper.on('click', 'textarea', function() {
      $(this).suggest('@', {
          data: get_default_tags($(this)),
          map: function(data) {
              return {
                  value: data.variable,
                  text: '<strong>' + data.variable + '</strong> <small>' + data.action + '</small>'
              }
          }
      });
      $(this).prev('.dropdown.suggest').find('.dropdown-menu').empty().append(get_suggested_tags($(this)));
    });

    $('.verticalTab').easyResponsiveTabs({
        type: 'vertical',
        width: 'auto',
        fit: true
    });


    function smwpcb_displayDataColumns(array, elementID, selectedID) {
      var strg = '';
      for (var i in array) {
          strg += '<tr>';
          strg += '<td>';
          strg += '<label><span class="smwpcb_switch_radio"><input type="radio" name="' + elementID + '" class="restoredvar" value="' + i + '" ' + ((i == selectedID) ? 'checked' : '') + '><i class="far fa-check-circle smwpcb_switch_radio_checked"></i><i class="far fa-circle smwpcb_switch_radio_unchecked"></i></span></label>';
          strg += '<input type="hidden" value="' + array[i]['column_validation'] + '" class="validationinput">';
          strg += '<input type="hidden" value="' + array[i]['column_validation_msg'] + '" class="validationmsginput">';
          strg += '</td>';
          strg += '<td>' + array[i]['name'] + '</td>';
          strg += '<td>' + array[i]['variable'] + '</td>';
          strg += '</tr>';
      }

      return strg;

    }

    function smwpcb_display_destination_topic(selectedVal, elementID) {
      var strg = '<select class="form-control closedDiscussion" element-id="' + elementID + '">';
      strg += "<option value='closeDisc' " + ((selectedVal == 'closeDisc') ? "selected='selected' " : "") + ">Close Discussion</option>";
      for (var i in smwpcb_wp_chatbot_topics_settings) {
          strg += "<option value='" + smwpcb_wp_chatbot_topics_settings[i]['smwpcb_topic_id'] + "' " + ((selectedVal == smwpcb_wp_chatbot_topics_settings[i]['smwpcb_topic_id']) ? "selected='selected' " : "") + ">";
          strg += smwpcb_wp_chatbot_topics_settings[i]['smwpcb_topic_name'];
          strg += "</option>";
      }
      strg += '</select>';

      return strg;
    }

    wrapper.on("click", ".options_bellow", function(e) { 
      e.preventDefault();
      var parent = $(this).closest('.executable');
      var panelcb = $(this).closest('.panelcb');
      var attr = panelcb.find('#restorevarscheck').attr('checked');
      var attr2 = panelcb.find('#usedefautrescheck').attr('checked');
      var attr3 = panelcb.find('#terminateTopicDest').attr('checked');
      if($(this).attr('class') == "resp-tab-item options_bellow add_children_button"){
        var parentID = $(this).attr('element-id');
        var elementID = (1000000000000000000 * Math.random()).toString();
        parentIDs.push(elementID);
        if(parent.find('ul.executableul').length && !parent.find('ul.restoreul' + parentID).length && !(typeof attr !== typeof undefined && attr !== false) && !(typeof attr3 !== typeof undefined && attr3 !== false)) {
          disable_choice_restore($(this));
          $(".tree").attr("style", "width:" + ($('.tree').width() + 535) + 'px');
          parent.find('ul.executableul').first().append(`
          <li class="executable">
            <div class="panelcb">
            <div class="infom infom` + parentID + `" element-id="` + elementID + `" parent-element="` + parentID + `">
            <div class="verticalTab" class="resp-vtabs" style="display: block; width: 100%; margin: 0px;"><!-- start vertical Tabs-->
              <ul class="resp-tabs-list">
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/keyword.png" alt="" /> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/paper.png" alt=""/> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/target.png" alt=""/> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/list.png" alt=""/> </span></li>
                <li class="resp-tab-item smwpcb_mortarboard"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/mortarboard.png" alt=""/> </span></li>
              </ul>
              <div class="resp-tabs-container">
                <span class="resp-arrow"></span><i class="icon_1"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Input Configuration</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    ` + (((typeof attr2 !== typeof undefined && attr2 !== false)) ? `<div class="form-group">
                          <label>Keywords Input</label> 
                          <div class="keywordstrgsclass">
                            <input class="form-control" type="text" id="keywordstriggers" value="" placeholder="Add keywords here" data-role="tagsinput" autocomplete="off"/>
                          </div>
                          <span id="helpBlock2" class="help-block">Enter the keywords of the input text that the user has to respond to the bot on this case.</span>
                        </div>` : ``) + `
                      
                      <div class="form-group">
                        <label>Quick reply button</label>
                        <input type="text" id="faqtriggers" class="form-control borderbottombluecolorred" placeholder="Quick reply" autocomplete="off">
                        <span class="help-block">Enter statement case reply that will be appeared as a fixed reply button.</span>
                      </div>
                      ` + (((typeof attr2 !== typeof undefined && attr2 !== false)) ? `<div class="form-group">
                        <label>Importance</label>
                        <input type="number" min="1" max="100" value="1" id="weight" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Which weight">
                        <span class="help-block">Specify the importance number from 1 to 100 so that if the input given by the user has keywords that exists in more than one case block with the same parents, the one with higher number will be reached.</span>
                      </div>` : ``) + `
                      
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_2"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Bot Messages</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <div class="form-group">
                        <label>Message bubble</label>
                        <div class="responsescontainer">
                        <textarea id="botresponse" class="botresponse form-control smwpcb_bubble_default" placeholder="Message bubble" rows="3"></textarea>
                        </div>
                        <img id="addresponse" title="Add Message Bubble" class="smwpch_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                        <span class="help-block">Set the messages that the bot will send the user on this case, click on add button to add more message bubbles.</span>
                    </div>
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_3"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Next Block</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <input type="hidden" value="1" id="resort_value">
                      <div class="smwpcb_margin_bottom radio">
                        <label>
                          <span class="smwpcb_switch_radio">
                            <input id="usedefautrescheck" type="radio" name="resort_` + elementID + `" value="1" checked>
                            <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                            <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                          </span>
                          Use keywords to target the next block for the conversation to flow.
                        </label>
                      </div>
                      <div class="smwpcb_margin_left dresToggle">
                        <div class="form-group">
                            <label>Default message</label>
                            <textarea id="defaultresponse" class="smwpcb_bubble_default form-control" placeholder="Message bubble" rows="3"></textarea>
                            <span class="help-block">Use this message bubble to entice users to write text having keywords from the already available block cases.</span>
                        </div>
                        <div class="form-group">
                            <label>Repeat Tolerance</label>
                            <input type="number" value="1" min="1" max="100" id="repeatTolerance" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Tolerance">
                            <span class="help-block">Write how many times you want your bot to repeat this message until it resorts to the fixed quick reply buttons.</span>
                        </div>
                        <div class="checkbox">
                          <label>
                            <span class="smwpcb_switch_checkbox">
                              <input id="storeusrmessage" type="checkbox" value="1">
                              <i class="fas fa-check-square smwpcb_switch_checked"></i>
                              <i class="fas fa-square smwpcb_switch_unchecked"></i>
                            </span>
                            Store the user reply of this block to the database
                          </label>
                        </div>
                        <div class="messagevarToggle" style="display:none;">
                          <div class="form-group">
                            <label>Stored as</label>
                            <input type="text" id="storedmsguser" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                            <span class="help-block">Enter the variable that you want the reply to be stored as.</span>
                          </div>
                        </div>
                      </div>
                      <div class="smwpcb_margin_bottom radio">
                        <label>
                          <span class="smwpcb_switch_radio">
                            <input id="restorevarscheck" type="radio" name="resort_` + elementID + `" value="1">
                            <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                            <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                          </span>
                          Restore the user input of this block into one of the available data column 
                        </label>
                      </div>
                      <div class="smwpcb_margin_left togglePanel" style="display:none">
                      <div class="panel panel-default">
                      <div class="panel-heading" style="text-align: center;">Available Columns</div>
                        <table class="table"> 
                         <thead> 
                          <tr> 
                            <th>Check</th> 
                            <th>Column Name</th> 
                            <th>Variable Name</th> 
                          </tr> 
                         </thead> 
                         <tbody> 
                          ` +
                              smwpcb_displayDataColumns(smwpcb_data_tables_settings, elementID, 0) +
                              ` 
                         </tbody>
                        </table>
                    </div>
                    <span class="help-block">These data columns can be manually set in the previous options, you can use the chosen @variable-name on the next message bubbles.</span>
                    </div> <!-- togglePanel -->
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="usefaqoptionscheck" type="radio" name="resort_` + elementID + `" value="1">
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Force the user to choose from the available fixed quick replies options
                      </label>
                    </div>
                    <div class="smwpcb_margin_left togglefaq" style="display:none">
                      <div class="checkbox" style="margin-top: -6px;">
                          <label>
                            <span class="smwpcb_switch_checkbox">
                              <input id="storeusrmessagefaq" type="checkbox" value="1">
                              <i class="fas fa-check-square smwpcb_switch_checked"></i>
                              <i class="fas fa-square smwpcb_switch_unchecked"></i>
                            </span>
                            Store the user choice this block to the database
                          </label>
                        </div>
                        <div class="messagefaqToggle" style="display:none;">
                          <div class="form-group">
                            <label>Stored as</label>
                            <input type="text" id="storedmsguserfaq" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                            <span class="help-block">Enter the variable that you want the choice to be stored as.</span>
                          </div>
                        </div>
                    </div>
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="terminateTopicDest" type="radio" name="resort_` + elementID + `" value="1">
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Close conversation or join this block to the other block cases for the conversation to flow.
                      </label>
                    </div>
                    <div class="smwpcb_margin_left terdestToggle" style="display:none">
                      <div class="form-group">
                        <label class="smwpcb_label_bottom">Please choose how you want to close the conversation</label>
                        ` + smwpcb_display_destination_topic('closeDisc', elementID) + `
                      </div>
                      <div class="toggleTopics"></div>
                      <span class="help-block">Choose from the next destination of the conversation, the blocks are distinguished by their first message of the bot. <br> <strong>Important:</strong>The bot messages of the chosen block will not be displayed by the bot.</span>
                    </div>
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_4"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Bot Tasks</h2>  
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <div class="checkbox smwpcb_margin_bottom">
                      <label>
                        <span class="smwpcb_switch_checkbox">
                          <input id="displayprod" type="checkbox" value="1">
                          <i class="fas fa-check-square smwpcb_switch_checked"></i>
                          <i class="fas fa-square smwpcb_switch_unchecked"></i>
                        </span>
                        Link on the bot messages of this block a descriptive card of a multiple products, articles, or links etc.
                      </label>
                    </div>
                    <div class="toggleProduct smwpcb_margin_left" style="display:none">
                      <div class="addPrdiv">
                        <div class="prodiv">
                        <div class="form-group">
                            <label>Image Url</label>
                            <input type="url" class="form-control borderbottombluecolorred imageurl" placeholder="http://" style="width: 90%;" autocomplete="off">
                        </div>
                        <div class="form-group">
                            <label>Link</label>
                            <input type="url" class="form-control borderbottombluecolorred linktocap" placeholder="http://" style="width: 90%;" autocomplete="off">
                        </div>
                        <div class="form-group">
                            <label>Title</label>
                            <input type="text" class="form-control borderbottombluecolorred titlecap" placeholder="please enter a title" style="width: 90%;" autocomplete="off">
                        </div>
                        <div class="form-group">
                            <label>Description</label>
                            <textarea rows="3" class="form-control borderbottombluecolorred descriptioncap" placeholder="please enter a description" style="width: 90%;"></textarea>
                        </div>
                        <div class="form-group">
                            <label>Text button</label>
                            <input type="text" class="form-control borderbottombluecolorred caption" placeholder="please enter a text button" style="width: 90%;" autocomplete="off">
                        </div>
                        </div>
                      </div>
                      <img id="addproduct" title="add card" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                    <div class="checkbox smwpcb_margin_bottom">
                      <label>
                        <span class="smwpcb_switch_checkbox">
                          <input type="checkbox" id="imageCheck" value="1">
                          <i class="fas fa-check-square smwpcb_switch_checked"></i>
                          <i class="fas fa-square smwpcb_switch_unchecked"></i>
                        </span>
                        Link on the bot messages of this block an image(s) or gif(s).
                      </label>
                    </div>
                    <div class="toggleImage smwpcb_margin_left" style="display:none">
                      <div class="addimagediv">
                        <div class="imagediv">
                          <div class="form-group">
                            <label>Image Url</label>
                            <input type="url" class="form-control borderbottombluecolorred imagedisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                          </div>
                        </div>
                      </div>
                      <img id="addimage" title="add image" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                  <div class="checkbox smwpcb_margin_bottom">
                      <label>
                      <span class="smwpcb_switch_checkbox">
                        <input type="checkbox" id="videoCheck" value="1">
                        <i class="fas fa-check-square smwpcb_switch_checked"></i>
                        <i class="fas fa-square smwpcb_switch_unchecked"></i>
                      </span>
                        Link on the bot messages of this block an embeded youtube video(s).
                      </label>
                    </div>
                    <div class="toggleVideo smwpcb_margin_left" style="display:none">
                      <div class="addvideodiv">
                        <div class="videodiv">
                          <div class="form-group">
                            <label>Video Url</label>
                            <input type="url" class="form-control borderbottombluecolorred videodisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                          </div>
                        </div>
                      </div>
                      <img id="addvideo" title="add video" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                  </div>
                </div> 
                  <span class="resp-arrow"></span><i class="icon_4"></i>
                  <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Train Your Bot</h2>
                    <h5>In this panel you may find users responses that didn't match any of the available children blocks</h5>
                    <div id="unsetedTriggers">
                      <div class="alert alert-info alert-dismissible" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        There's no unsolved users response yet.
                      </div>
                    </div>
                  </div>
                </div>
            </div>
            </div>      
           </div>
           <div class="clearfix"> </div>
           <div class="chatbotTools" >
              <ul class="resp-tabs-list" style="position: absolute; left:71px">
              <li class="resp-tab-item cbpanelzoom" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/zoom-in.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow reduce_panel" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/caret-arrow-up.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow add_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/plus.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow delete_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/remove.png" alt=""/> </span></div></li>
              </ul>
             </div>
          </div>
          </li>`);
        }else if(!parent.find('ul.executableul').length && !(typeof attr !== typeof undefined && attr !== false) && !(typeof attr3 !== typeof undefined && attr3 !== false)) {
          disable_choice_restore($(this));
          if (!(typeof attr2 !== typeof undefined && attr2 !== false)) {
              disable_unsetted_use_case($(this));
          }
          $(this).closest('li.executable').append(`
          <ul class="executableul">
          <li class="executable">
            <div class="panelcb">
            <div class="infom infom` + parentID + `" element-id="` + elementID + `" parent-element="` + parentID + `">
            <div class="verticalTab" class="resp-vtabs" style="display: block; width: 100%; margin: 0px;"><!-- start vertical Tabs-->
              <ul class="resp-tabs-list">
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/keyword.png" alt="" /> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/paper.png" alt=""/> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/target.png" alt=""/> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/list.png" alt=""/> </span></li>
                <li class="resp-tab-item smwpcb_mortarboard"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/mortarboard.png" alt=""/> </span></li>
              </ul>
              <div class="resp-tabs-container">
                <span class="resp-arrow"></span><i class="icon_1"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Input Configuration</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    ` + (((typeof attr2 !== typeof undefined && attr2 !== false)) ? `<div class="form-group">
                          <label>Keywords Input</label> 
                          <div class="keywordstrgsclass">
                            <input class="form-control" type="text" id="keywordstriggers" value="" placeholder="Add keywords here" data-role="tagsinput" autocomplete="off"/>
                          </div>
                          <span id="helpBlock2" class="help-block">Enter the keywords of the input text that the user has to respond to the bot on this case.</span>
                        </div>` : ``) + `
                      
                      <div class="form-group">
                        <label>Quick reply button</label>
                        <input type="text" id="faqtriggers" class="form-control borderbottombluecolorred" placeholder="Quick reply" autocomplete="off">
                        <span class="help-block">Enter statement case reply that will be appeared as a fixed reply button.</span>
                      </div>
                      ` + (((typeof attr2 !== typeof undefined && attr2 !== false)) ? `<div class="form-group">
                        <label>Importance</label>
                        <input type="number" min="1" max="100" value="1" id="weight" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Which weight">
                        <span class="help-block">Specify the importance number from 1 to 100 so that if the input given by the user has keywords that exists in more than one case block with the same parents, the one with higher number will be reached.</span>
                      </div>` : ``) + `
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_2"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Bot Messages</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <div class="form-group">
                        <label>Message bubble</label>
                        <div class="responsescontainer">
                        <textarea id="botresponse" class="botresponse form-control smwpcb_bubble_default" placeholder="Message bubble" rows="3"></textarea>
                        </div>
                        <img id="addresponse" title="Add Message Bubble" class="smwpch_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                        <span class="help-block">Set the messages that the bot will send the user on this case, click on add button to add more message bubbles.</span>
                    </div>
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_3"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Next Block</h2>
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <input type="hidden" value="1" id="resort_value">
                      <div class="smwpcb_margin_bottom radio">
                        <label>
                          <span class="smwpcb_switch_radio">
                            <input id="usedefautrescheck" type="radio" name="resort_` + elementID + `" value="1" checked>
                            <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                            <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                          </span>
                          Use keywords to target the next block for the conversation to flow.
                        </label>
                      </div>
                      <div class="smwpcb_margin_left dresToggle">
                        <div class="form-group">
                            <label>Default message</label>
                            <textarea id="defaultresponse" class="smwpcb_bubble_default form-control" placeholder="Message bubble" rows="3"></textarea>
                            <span class="help-block">Use this message bubble to entice users to write text having keywords from the already available block cases.</span>
                        </div>
                        <div class="form-group">
                            <label>Repeat Tolerance</label>
                            <input type="number" value="1" min="1" max="100" id="repeatTolerance" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Tolerance">
                            <span class="help-block">Write how many times you want your bot to repeat this message until it resorts to the fixed quick reply buttons.</span>
                        </div>
                        <div class="checkbox">
                          <label>
                            <span class="smwpcb_switch_checkbox">
                              <input id="storeusrmessage" type="checkbox" value="1">
                              <i class="fas fa-check-square smwpcb_switch_checked"></i>
                              <i class="fas fa-square smwpcb_switch_unchecked"></i>
                            </span>
                            Store the user reply of this block to the database
                          </label>
                        </div>
                        <div class="messagevarToggle" style="display:none;">
                          <div class="form-group">
                            <label>Stored as</label>
                            <input type="text" id="storedmsguser" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                            <span class="help-block">Enter the variable that you want the reply to be stored as.</span>
                          </div>
                        </div>
                      </div>
                      <div class="smwpcb_margin_bottom radio">
                        <label>
                          <span class="smwpcb_switch_radio">
                            <input id="restorevarscheck" type="radio" name="resort_` + elementID + `" value="1">
                            <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                            <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                          </span>
                          Restore the user input of this block into one of the available data column 
                        </label>
                      </div>
                      <div class="smwpcb_margin_left togglePanel" style="display:none">
                      <div class="panel panel-default">
                      <div class="panel-heading" style="text-align: center;">Available Columns</div>
                        <table class="table"> 
                         <thead> 
                          <tr> 
                            <th>Check</th> 
                            <th>Column Name</th> 
                            <th>Variable Name</th> 
                          </tr> 
                         </thead> 
                         <tbody> 
                          ` +
                              smwpcb_displayDataColumns(smwpcb_data_tables_settings, elementID, 0) +
                              ` 
                         </tbody>
                        </table>
                    </div>
                    <span class="help-block">These data columns can be manually set in the previous options, you can use the chosen @variable-name on the next message bubbles.</span>
                    </div> <!-- togglePanel -->
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="usefaqoptionscheck" type="radio" name="resort_` + elementID + `" value="1">
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Force the user to choose from the available fixed quick replies options
                      </label>
                    </div>
                    <div class="smwpcb_margin_left togglefaq" style="display:none">
                      <div class="checkbox" style="margin-top: -6px;">
                          <label>
                            <span class="smwpcb_switch_checkbox">
                              <input id="storeusrmessagefaq" type="checkbox" value="1">
                              <i class="fas fa-check-square smwpcb_switch_checked"></i>
                              <i class="fas fa-square smwpcb_switch_unchecked"></i>
                            </span>
                            Store the user choice this block to the database
                          </label>
                        </div>
                        <div class="messagefaqToggle" style="display:none;">
                          <div class="form-group">
                            <label>Stored as</label>
                            <input type="text" id="storedmsguserfaq" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                            <span class="help-block">Enter the variable that you want the choice to be stored as.</span>
                          </div>
                        </div>
                    </div>
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="terminateTopicDest" type="radio" name="resort_` + elementID + `" value="1">
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Close conversation or join this block to the other block cases for the conversation to flow.
                      </label>
                    </div>
                    <div class="smwpcb_margin_left terdestToggle" style="display:none">
                      <div class="form-group">
                        <label class="smwpcb_label_bottom">Please choose how you want to close the conversation</label>
                        ` + smwpcb_display_destination_topic('closeDisc', elementID) + `
                      </div>
                      <div class="toggleTopics"></div>
                      <span class="help-block">Choose from the next destination of the conversation, the blocks are distinguished by their first message of the bot. <br> <strong>Important:</strong>The bot messages of the chosen block will not be displayed by the bot.</span>
                    </div>
                  </div>
                </div>
                <span class="resp-arrow"></span><i class="icon_4"></i>
                <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Bot Tasks</h2>  
                    <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                    <div class="checkbox smwpcb_margin_bottom">
                      <label>
                        <span class="smwpcb_switch_checkbox">
                          <input id="displayprod" type="checkbox" value="1">
                          <i class="fas fa-check-square smwpcb_switch_checked"></i>
                          <i class="fas fa-square smwpcb_switch_unchecked"></i>
                        </span>
                        Link on the bot messages of this block a descriptive card of a multiple products, articles, or links etc.
                      </label>
                    </div>
                    <div class="toggleProduct smwpcb_margin_left" style="display:none">
                      <div class="addPrdiv">
                        <div class="prodiv">
                        <div class="form-group">
                            <label>Image Url</label>
                            <input type="url" class="form-control borderbottombluecolorred imageurl" placeholder="http://" autocomplete="off" style="width: 90%;">
                        </div>
                        <div class="form-group">
                            <label>Link</label>
                            <input type="url" class="form-control borderbottombluecolorred linktocap" placeholder="http://" autocomplete="off" style="width: 90%;">
                        </div>
                        <div class="form-group">
                            <label>Title</label>
                            <input type="text" class="form-control borderbottombluecolorred titlecap" placeholder="please enter a title" autocomplete="off" style="width: 90%;">
                        </div>
                        <div class="form-group">
                            <label>Description</label>
                            <textarea rows="3" class="form-control borderbottombluecolorred descriptioncap" placeholder="please enter a description" style="width: 90%;"></textarea>
                        </div>
                        <div class="form-group">
                            <label>Text button</label>
                            <input type="text" class="form-control borderbottombluecolorred caption" placeholder="please enter a text button" autocomplete="off" style="width: 90%;">
                        </div>
                        </div>
                      </div>
                      <img id="addproduct" title="add card" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                    <div class="checkbox smwpcb_margin_bottom">
                      <label>
                        <span class="smwpcb_switch_checkbox">
                          <input type="checkbox" id="imageCheck" value="1">
                          <i class="fas fa-check-square smwpcb_switch_checked"></i>
                          <i class="fas fa-square smwpcb_switch_unchecked"></i>
                        </span>
                        Link on the bot messages of this block an image(s) or gif(s).
                      </label>
                    </div>
                    <div class="toggleImage smwpcb_margin_left" style="display:none">
                      <div class="addimagediv">
                        <div class="imagediv">
                          <div class="form-group">
                            <label>Image Url</label>
                            <input type="url" class="form-control borderbottombluecolorred imagedisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                          </div>
                        </div>
                      </div>
                      <img id="addimage" title="add image" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                  <div class="checkbox smwpcb_margin_bottom">
                      <label>
                      <span class="smwpcb_switch_checkbox">
                        <input type="checkbox" id="videoCheck" value="1">
                        <i class="fas fa-check-square smwpcb_switch_checked"></i>
                        <i class="fas fa-square smwpcb_switch_unchecked"></i>
                      </span>
                        Link on the bot messages of this block an embeded youtube video(s).
                      </label>
                    </div>
                    <div class="toggleVideo smwpcb_margin_left" style="display:none">
                      <div class="addvideodiv">
                        <div class="videodiv">
                          <div class="form-group">
                            <label>Video Url</label>
                            <input type="url" class="form-control borderbottombluecolorred videodisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                          </div>
                        </div>
                      </div>
                      <img id="addvideo" title="add video" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                    </div>
                  </div>
                </div> 
                  <span class="resp-arrow"></span><i class="icon_4"></i>
                  <div class="new_posts resp-tab-content">
                  <div class="contact-form1">
                    <h2>Train Your Bot</h2>
                    <h5>In this panel you may find users responses that didn't match any of the available children blocks</h5>
                    <div id="unsetedTriggers">
                      <div class="alert alert-info alert-dismissible" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        There is no unsolved users response yet.
                      </div>
                    </div>
                  </div>
                </div>
            </div>
            </div>      
           </div>
           <div class="clearfix"> </div>
           <div class="chatbotTools" >
              <ul class="resp-tabs-list" style="position: absolute; left:71px">
              <li class="resp-tab-item cbpanelzoom" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/zoom-in.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow reduce_panel" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/caret-arrow-up.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow add_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/plus.png" alt=""/> </span></div></li>
                <li class="resp-tab-item options_bellow delete_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/remove.png" alt=""/> </span></div></li>
              </ul>
             </div>
          </div>
          </li>
          </ul>`);
      }else if(!parent.find('ul.executableul').length && (typeof attr !== typeof undefined && attr !== false) && (!(typeof attr3 !== typeof undefined && attr3 !== false) || !parent.find('#terminateTopicDest').length)) {
          disable_choice_restore($(this));
          disable_unsetted_use_case($(this));
          $(this).closest('li.executable').append(`
            <ul class="executableul restoreul` + parentID + `"> 
              <li class="executable">
              <div class="panelcb">
              <div class="infom infom` + parentID + `" element-id="` + elementID + `" parent-element="` + parentID + `">
              <div class="verticalTab" class="resp-vtabs" style="display: block; width: 100%; margin: 0px;"><!-- start vertical Tabs-->
              <ul class="resp-tabs-list fixnavbarheight">
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/paper.png" alt="" /> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/target.png" alt=""/> </span></li>
                <li class="resp-tab-item"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/list.png" alt=""/> </span></li>
                <li class="resp-tab-item smwpcb_mortarboard"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/mortarboard.png" alt=""/> </span></li>
              </ul>
            <div class="resp-tabs-container">
              <span class="resp-arrow"></span><i class="icon_2"></i>
              <div class="new_posts resp-tab-content">
                <div class="contact-form1">
                  <h2>Bot Messages</h2>
                  <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                  <div class="form-group">
                      <label>Message bubble</label>
                      <div class="responsescontainer">
                      <textarea id="botresponse" class="botresponse form-control smwpcb_bubble_default" placeholder="Message bubble" rows="3"></textarea>
                      </div>
                      <img id="addresponse" title="Add Message Bubble" class="smwpch_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                      <span class="help-block">Set the messages that the bot will send the user on this case, click on add button to add more message bubbles.</span>
                  </div>
                </div>
              </div>
              <span class="resp-arrow"></span><i class="icon_3"></i>
              <div class="new_posts resp-tab-content">
                <div class="contact-form1">
                  <h2>Next Block</h2>
                  <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                  <input type="hidden" value="1" id="resort_value">
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="usedefautrescheck" type="radio" name="resort_` + elementID + `" value="1" checked>
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Use keywords to target the next block for the conversation to flow.
                      </label>
                    </div>
                    <div class="smwpcb_margin_left dresToggle">
                      <div class="form-group">
                          <label>Default message</label>
                          <textarea id="defaultresponse" class="smwpcb_bubble_default form-control" placeholder="Message bubble" rows="3"></textarea>
                          <span class="help-block">Use this message bubble to entice users to write text having keywords from the already available block cases.</span>
                      </div>
                      <div class="form-group">
                          <label>Repeat Tolerance</label>
                          <input type="number" value="1" min="1" max="100" id="repeatTolerance" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Tolerance">
                          <span class="help-block">Write how many times you want your bot to repeat this message until it resorts to the fixed quick reply buttons.</span>
                      </div>
                      <div class="checkbox">
                        <label>
                          <span class="smwpcb_switch_checkbox">
                            <input id="storeusrmessage" type="checkbox" value="1">
                            <i class="fas fa-check-square smwpcb_switch_checked"></i>
                            <i class="fas fa-square smwpcb_switch_unchecked"></i>
                          </span>
                          Store the user reply of this block to the database
                        </label>
                      </div>
                      <div class="messagevarToggle" style="display:none;">
                        <div class="form-group">
                          <label>Stored as</label>
                          <input type="text" id="storedmsguser" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                          <span class="help-block">Enter the variable that you want the reply to be stored as.</span>
                        </div>
                      </div>
                    </div>
                    <div class="smwpcb_margin_bottom radio">
                      <label>
                        <span class="smwpcb_switch_radio">
                          <input id="restorevarscheck" type="radio" name="resort_` + elementID + `" value="1">
                          <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                          <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                        </span>
                        Restore the user input of this block into one of the available data column 
                      </label>
                    </div>
                    <div class="smwpcb_margin_left togglePanel" style="display:none">
                    <div class="panel panel-default">
                    <div class="panel-heading" style="text-align: center;">Available Columns</div>
                      <table class="table"> 
                       <thead> 
                        <tr> 
                          <th>Check</th> 
                          <th>Column Name</th> 
                          <th>Variable Name</th> 
                        </tr> 
                       </thead> 
                       <tbody> 
                        ` +
                            smwpcb_displayDataColumns(smwpcb_data_tables_settings, elementID, 0) +
                            ` 
                       </tbody>
                      </table>
                  </div>
                  <span class="help-block">These data columns can be manually set in the previous options, you can use the chosen @variable-name on the next message bubbles.</span>
                  </div> <!-- togglePanel -->
                  <div class="smwpcb_margin_bottom radio">
                    <label>
                      <span class="smwpcb_switch_radio">
                        <input id="usefaqoptionscheck" type="radio" name="resort_` + elementID + `" value="1">
                        <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                        <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                      </span>
                      Force the user to choose from the available fixed quick replies options
                    </label>
                  </div>
                  <div class="smwpcb_margin_left togglefaq" style="display:none">
                    <div class="checkbox" style="margin-top: -6px;">
                        <label>
                          <span class="smwpcb_switch_checkbox">
                            <input id="storeusrmessagefaq" type="checkbox" value="1">
                            <i class="fas fa-check-square smwpcb_switch_checked"></i>
                            <i class="fas fa-square smwpcb_switch_unchecked"></i>
                          </span>
                          Store the user choice this block to the database
                        </label>
                      </div>
                      <div class="messagefaqToggle" style="display:none;">
                        <div class="form-group">
                          <label>Stored as</label>
                          <input type="text" id="storedmsguserfaq" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                          <span class="help-block">Enter the variable that you want the choice to be stored as.</span>
                        </div>
                      </div>
                  </div>
                  <div class="smwpcb_margin_bottom radio">
                    <label>
                      <span class="smwpcb_switch_radio">
                        <input id="terminateTopicDest" type="radio" name="resort_` + elementID + `" value="1">
                        <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                        <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                      </span>
                      Close conversation or join this block to the other block cases for the conversation to flow.
                    </label>
                  </div>
                  <div class="smwpcb_margin_left terdestToggle" style="display:none">
                    <div class="form-group">
                      <label class="smwpcb_label_bottom">Please choose how you want to close the conversation</label>
                      ` + smwpcb_display_destination_topic('closeDisc', elementID) + `
                    </div>
                    <div class="toggleTopics"></div>
                    <span class="help-block">Choose from the next destination of the conversation, the blocks are distinguished by their first message of the bot. <br> <strong>Important:</strong>The bot messages of the chosen block will not be displayed by the bot.</span>
                  </div>
                </div>
              </div>
              <span class="resp-arrow"></span><i class="icon_4"></i>
              <div class="new_posts resp-tab-content">
                <div class="contact-form1">
                  <h2>Bot Tasks</h2>  
                  <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                  <div class="checkbox smwpcb_margin_bottom">
                    <label>
                      <span class="smwpcb_switch_checkbox">
                        <input id="displayprod" type="checkbox" value="1">
                        <i class="fas fa-check-square smwpcb_switch_checked"></i>
                        <i class="fas fa-square smwpcb_switch_unchecked"></i>
                      </span>
                      Link on the bot messages of this block a descriptive card of a multiple products, articles, or links etc.
                    </label>
                  </div>
                  <div class="toggleProduct smwpcb_margin_left" style="display:none">
                    <div class="addPrdiv">
                      <div class="prodiv">
                      <div class="form-group">
                          <label>Image Url</label>
                          <input type="url" class="form-control borderbottombluecolorred imageurl" placeholder="http://" style="width: 90%;" autocomplete="off">
                      </div>
                      <div class="form-group">
                          <label>Link</label>
                          <input type="url" class="form-control borderbottombluecolorred linktocap" placeholder="http://" style="width: 90%;" autocomplete="off">
                      </div>
                      <div class="form-group">
                          <label>Title</label>
                          <input type="text" class="form-control borderbottombluecolorred titlecap" placeholder="please enter a title" style="width: 90%;" autocomplete="off">
                      </div>
                      <div class="form-group">
                          <label>Description</label>
                          <textarea rows="3" class="form-control borderbottombluecolorred descriptioncap" placeholder="please enter a description" style="width: 90%;"></textarea>
                      </div>
                      <div class="form-group">
                          <label>Text button</label>
                          <input type="text" class="form-control borderbottombluecolorred caption" placeholder="please enter a text button" style="width: 90%;" autocomplete="off">
                      </div>
                      </div>
                    </div>
                    <img id="addproduct" title="add card" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                  </div>
                  <div class="checkbox smwpcb_margin_bottom">
                    <label>
                      <span class="smwpcb_switch_checkbox">
                        <input type="checkbox" id="imageCheck" value="1">
                        <i class="fas fa-check-square smwpcb_switch_checked"></i>
                        <i class="fas fa-square smwpcb_switch_unchecked"></i>
                      </span>
                      Link on the bot messages of this block an image(s) or gif(s).
                    </label>
                  </div>
                  <div class="toggleImage smwpcb_margin_left" style="display:none">
                    <div class="addimagediv">
                      <div class="imagediv">
                        <div class="form-group">
                          <label>Image Url</label>
                          <input type="url" class="form-control borderbottombluecolorred imagedisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                        </div>
                      </div>
                    </div>
                    <img id="addimage" title="add image" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                  </div>
                <div class="checkbox smwpcb_margin_bottom">
                    <label>
                    <span class="smwpcb_switch_checkbox">
                      <input type="checkbox" id="videoCheck" value="1">
                      <i class="fas fa-check-square smwpcb_switch_checked"></i>
                      <i class="fas fa-square smwpcb_switch_unchecked"></i>
                    </span>
                      Link on the bot messages of this block an embeded youtube video(s).
                    </label>
                  </div>
                  <div class="toggleVideo smwpcb_margin_left" style="display:none">
                    <div class="addvideodiv">
                      <div class="videodiv">
                        <div class="form-group">
                          <label>Video Url</label>
                          <input type="url" class="form-control borderbottombluecolorred videodisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                        </div>
                      </div>
                    </div>
                    <img id="addvideo" title="add video" class="smwpcb_add_product" src="` + smwpcb_custom_ui_topics_link.image_path + `/add-message.png">
                  </div>
                </div>
              </div> 
               <span class="resp-arrow"></span><i class="icon_4"></i>
                <div class="new_posts resp-tab-content">
                <div class="contact-form1">
                  <h2>Train Your Bot</h2>
                  <h5>In this panel you may find users responses that didn't match any of the available children blocks</h5>
                  <div id="unsetedTriggers">
                    <div class="alert alert-info alert-dismissible" role="alert">
                      <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                      There is no unsolved users response yet.
                    </div>
                  </div>
                </div>
              </div> 
          </div>
          </div>      
         </div>
         <div class="clearfix"> </div>
         <div class="chatbotTools" >
            <ul class="resp-tabs-list" style="position: absolute; left:71px">
            <li class="resp-tab-item cbpanelzoom" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/zoom-in.png" alt=""/> </span></div></li>
              <li class="resp-tab-item options_bellow reduce_panel" style="width:106px;"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/caret-arrow-up.png" alt=""/> </span></div></li>
              <li class="resp-tab-item options_bellow add_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/plus.png" alt=""/> </span></div></li>
              <li class="resp-tab-item options_bellow delete_children_button" style="width:106px;" element-id="` + elementID + `"><div style="width:100%;height:25px"><span><img src="` + smwpcb_custom_ui_topics_link.image_path + `/remove.png" alt=""/> </span></div></li>
            </ul>
           </div>
        </div>
        </li>
        </ul>`);
          }else if(parent.find('#terminateTopicDest').length && (typeof attr3 !== typeof undefined && attr3 !== false)) {
              alert('You can\'t add another child of a closed discussion');
          }else{
              alert('You can\'t add another child of the dialog that stores users data');
          }
          $('.verticalTab').easyResponsiveTabs({
              type: 'vertical',
              width: 'auto',
              fit: true
          });
          $("input[data-role=tagsinput], select[multiple][data-role=tagsinput]").tagsinput();
        }else if($(this).attr('class') == "resp-tab-item options_bellow delete_children_button") {
            if (window.confirm("Are you sure you want to delete this block ?")) {
              var parenttoremove = $(this).attr('element-id');
              var elementstoremove = [];
              elementstoremove.push(parenttoremove);
              wrapper.find('.infom[parent-element="' + parenttoremove + '"]').each(function() {
                  elementstoremove.push($(this).attr('element-id'));
              });
              parentIDs = jQuery.grep(parentIDs, function(value) {
                  for (var i = 0; i < elementstoremove.length; i++) {
                      if (elementstoremove[i] == value) {
                          return false;
                      }
                  }
                  return true;
              });
              if(parent.closest('ul').children().length == 1) {
                  enable_choice_restore(parent.closest('ul').closest('li.executable').find('.panelcb'));
                  enable_unsetted_use_case(parent.closest('ul').closest('li.executable').find('.panelcb'))
                  parent.closest('ul').remove();
              }else{
                  parent.remove();
              }
            }
      }else{
          if(panelcb.height() >= 500){
            $(this).find('img').attr('src', smwpcb_custom_ui_topics_link.image_path + '/caret-down.png');
            panelcb.height(53);
          }else{
            $(this).find('img').attr('src', smwpcb_custom_ui_topics_link.image_path + '/caret-arrow-up.png');
            panelcb.height(540);
          }
          panelcb.find('.infom').slideToggle();
      }
      smwpcb_solve_verticaltab();
      if (window.onbeforeunload == null) {
          window.onbeforeunload = function() {
              return "Data will be lost if you leave the page, are you sure?";
          };
      }
    });

    function smwpcb_solve_verticaltab() {
      wrapper.find('.panelcb').each(function() {
          $(this).find('.resp-tab-item').each(function(key, element) {
              if (key == 0) {
                  $(this).addClass('resp-tab-active')
              } else if ($(this).hasClass('resp-tab-active')) {
                  $(this).removeClass('resp-tab-active');
              }
          });
          $(this).find('.new_posts').each(function(key, element) {
              if (key == 0) {
                  $(this).addClass('resp-tab-content-active');
                  $(this).css("display", "block");
              } else if ($(this).hasClass('resp-tab-content-active')) {
                  $(this).removeClass('resp-tab-content-active');
                  $(this).removeAttr('style');
              }
          });
      });
    }

    function smwpcb_reduce_all_panels() {
        wrapper.find('.panelcb').each(function() {
            $(this).find('.reduce_panel img').attr('src', smwpcb_custom_ui_topics_link.image_path + '/caret-down.png');
            $(this).height(53);
            $(this).find('.infom').attr('style', 'display:none');
        });
    }


    function smwpcb_remove_back_slashes() {
        wrapper.find('input[type="text"]').each(function() {
            $(this).attr('value', $(this).attr('value').smwpcb_replace_all("\\", ""));
        });
        wrapper.find('textarea').each(function() {
            $(this).text($(this).text().smwpcb_replace_all("\\", ""));
        });
    }


    $('#saveSettings').on('click', function(e) {
        e.preventDefault();
        var idkey = $(this).attr('idkey');
        $('.modal').attr('style', 'display:block');
        smwpcb_removeRedBackForValidation();
        if (smwpcb_stories_validation()) {
            wrapper.find('input#parentIDsInput').attr('value', parentIDs.join());
            var allofInputs = [];
            for (var i = 0; i < parentIDs.length; i++) {
                var responses = [];
                var checkrestore = '';
                var displayprod = '';
                var restoredvar = '';
                var checkedvar = [];
                var checkrestorevar = '';
                var imageCheck = '';
                var videoCheck = '';
                var childrenQst = wrapper.find('.infom' + parentIDs[i]);
                var inputCB = {
                    'values': {},
                    'children': [],
                    'elementID': parentIDs[i]
                };
                var valuesAtt = {
                    'responses': [],
                    'restore': [],
                    'functions': []
                };
                checkrestore = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('input[name^="resort"]:checked');
                displayprod = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#displayprod');
                imageCheck = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#imageCheck');
                videoCheck = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#videoCheck');
                restoredvar = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('.restoredvar');
                if (i == 0) {
                    var responsesFst = [];
                    wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('.botresponse').each(function() {
                        responsesFst.push($(this).val().smwpcb_replace_all('"', ''));
                    });
                    valuesAtt['responses'] = [responsesFst, wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#defaultresponse').val().smwpcb_replace_all('"', '')];
                }
                if (checkrestore.attr('id') == 'usedefautrescheck') {
                    checkrestorevar = "1";
                    if (i != 0) {
                        valuesAtt['responses'] = [wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#botresponse').val().smwpcb_replace_all('"', ''), wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#defaultresponse').val().smwpcb_replace_all('"', '')];
                    }
                    checkedvar[0] = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#repeatTolerance').val().smwpcb_replace_all('"', '');

                    if (wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#storeusrmessage').is(':checked')) {
                        checkedvar[1] = 'yes';
                        checkedvar[2] = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#storedmsguser').val().smwpcb_replace_all('"', '');
                    } else {
                        checkedvar[1] = 'no';
                    }
                } else if (checkrestore.attr('id') == 'restorevarscheck') {
                    checkrestorevar = "2";
                    restoredvar.each(function() {
                        if ($(this).is(':checked')) {
                            checkedvar[0] = $(this).val().smwpcb_replace_all('"', '');
                            checkedvar[1] = $(this).closest('td').find('.validationinput').val().smwpcb_replace_all('"', '');
                            checkedvar[2] = $(this).closest('td').find('.validationmsginput').val().smwpcb_replace_all('"', '');
                        }
                    });
                } else if (checkrestore.attr('id') == 'terminateTopicDest') {
                    checkrestorevar = "4";
                    checkedvar[0] = $(this).closest('.contact-form1').find('.closedDiscussion').val();
                } else if (checkrestore.attr('id') == 'usefaqoptionscheck') {
                    if (i != 0) {
                        valuesAtt['responses'] = [wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#botresponse').val().smwpcb_replace_all('"', '')];
                    }
                    checkrestorevar = "3";
                    if (wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#storeusrmessagefaq').is(':checked')) {
                        checkedvar[1] = 'yes';
                        checkedvar[2] = wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('#storedmsguserfaq').val().smwpcb_replace_all('"', '');
                    } else {
                        checkedvar[1] = 'no';
                    }
                }
                if (displayprod.is(':checked')) {
                    var prodivs = [];
                    wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('.prodiv').each(function() {
                        prodivs.push([$(this).find('.imageurl').val().smwpcb_replace_all('"', ''), $(this).find('.linktocap').val().smwpcb_replace_all('"', ''), $(this).find('.titlecap').val().smwpcb_replace_all('"', ''), $(this).find('.descriptioncap').val().smwpcb_replace_all('"', ''), $(this).find('.caption').val().smwpcb_replace_all('"', '')]);
                    });
                    valuesAtt['functions'].push([displayprod.val().smwpcb_replace_all('"', ''), prodivs]);
                } else {
                    valuesAtt['functions'].push(['0']);
                }
                // for weathercheck I'll add it on the next updates
                valuesAtt['functions'].push(['0']);
                // for google search I'll add it on the next updates
                valuesAtt['functions'].push(['0']);
                if (imageCheck.is(':checked')) {
                    var imagedivs = [];
                    wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('.imagediv').each(function() {
                        imagedivs.push($(this).find('.imagedisplayurl').val().smwpcb_replace_all('"', ''));
                    });
                    valuesAtt['functions'].push([imageCheck.val().smwpcb_replace_all('"', ''), imagedivs]);
                } else {
                    valuesAtt['functions'].push(['0']);
                }
                if (videoCheck.is(':checked')) {
                    var videodivs = [];
                    wrapper.find('.infom[element-id="' + parentIDs[i] + '"]').find('.videodiv').each(function() {
                        videodivs.push($(this).find('.videodisplayurl').val().smwpcb_replace_all('"', ''));
                    });
                    valuesAtt['functions'].push([videoCheck.val().smwpcb_replace_all('"', ''), videodivs]);
                } else {
                    valuesAtt['functions'].push(['0']);
                }
                valuesAtt['restore'] = [checkrestorevar, checkedvar];
                inputCB['values'] = valuesAtt;
                childrenQst.each(function() {
                  var childrenAtt = {
                      'triggers': [],
                      'responses': [],
                      'restore': [],
                      'functions': [],
                      'unset': [''],
                      'elementID': ''
                  };

                  responses = [];
                  var checkrestorechild = $(this).find('input[name^="resort"]:checked');
                  var displayprodchild = $(this).find('#displayprod');
                  var imageCheckchild = $(this).find('#imageCheck');
                  var videoCheckchild = $(this).find('#videoCheck');
                  var checkedvarchild = [];
                  var checkrestorevarchild = '';

                  if (checkrestorechild.attr('id') == 'usedefautrescheck') {
                      checkedvarchild[0] = $(this).find('#repeatTolerance').val().smwpcb_replace_all('"', '');
                      if ($(this).find('#storeusrmessage').is(':checked')) {
                          checkedvarchild[1] = 'yes';
                          checkedvarchild[2] = $(this).find('#storedmsguser').val().smwpcb_replace_all('"', '');
                      } else {
                          checkedvarchild[1] = 'no';
                      }
                      checkrestorevarchild = "1";
                  } else if (checkrestorechild.attr('id') == 'restorevarscheck') {
                      checkrestorevarchild = "2";
                      $(this).find('.restoredvar').each(function() {
                          if ($(this).is(':checked')) {
                              checkedvarchild[0] = $(this).val().smwpcb_replace_all('"', '');
                              checkedvarchild[1] = $(this).closest('td').find('.validationinput').val().smwpcb_replace_all('"', '');
                              checkedvarchild[2] = $(this).closest('td').find('.validationmsginput').val().smwpcb_replace_all('"', '');
                          }
                      });
                  } else if (checkrestorechild.attr('id') == 'terminateTopicDest') {
                      checkrestorevarchild = "4";
                      checkedvarchild[0] = $(this).find('.closedDiscussion').val().smwpcb_replace_all('"', '');
                      $(this).find('.toggleTopics input').each(function() {
                          if ($(this).is(':checked')) {
                              checkedvarchild[1] = $(this).val().smwpcb_replace_all('"', '');
                              checkedvarchild[2] = $(this).closest('tr').find('.firstmessagetopic').val().smwpcb_replace_all('"', '');
                              checkedvarchild[3] = $(this).closest('tr').find('.faqoptionsdisplay').val().smwpcb_replace_all('"', '');
                              checkedvarchild[4] = $(this).closest('tr').find('.typeTrigger').val().smwpcb_replace_all('"', '');
                              checkedvarchild[5] = $(this).closest('tr').find('.restoreoption').val().smwpcb_replace_all('"', '');
                          }
                      });
                  } else if (checkrestorechild.attr('id') == 'usefaqoptionscheck') {
                      if ($(this).find('#storeusrmessagefaq').is(':checked')) {
                          checkedvarchild[1] = 'yes';
                          checkedvarchild[2] = $(this).find('#storedmsguserfaq').val().smwpcb_replace_all('"', '');
                      } else {
                          checkedvarchild[1] = 'no';
                      }
                      checkrestorevarchild = "3";
                  }

                  $(this).find('.botresponse').each(function() {
                      responses.push($(this).val().smwpcb_replace_all('"', ''));
                  });

                  if (displayprodchild.is(':checked')) {
                      var prodivs = [];
                      $(this).find('.prodiv').each(function() {
                          prodivs.push([$(this).find('.imageurl').val().smwpcb_replace_all('"', ''), $(this).find('.linktocap').val().smwpcb_replace_all('"', ''), $(this).find('.titlecap').val().smwpcb_replace_all('"', ''), $(this).find('.descriptioncap').val().smwpcb_replace_all('"', ''), $(this).find('.caption').val().smwpcb_replace_all('"', '')]);
                      });

                      childrenAtt['functions'].push([displayprodchild.val().smwpcb_replace_all('"', ''), prodivs]);
                  } else {
                      childrenAtt['functions'].push(['0']);
                  }
                  // for weathercheck I'll add it on the next updates
                  childrenAtt['functions'].push(['0']);
                  // for google search I'll add it on the next updates
                  childrenAtt['functions'].push(['0']);

                  if (imageCheckchild.is(':checked')) {
                      var imagedivs = [];
                      $(this).find('.imagediv').each(function() {
                          imagedivs.push($(this).find('.imagedisplayurl').val().smwpcb_replace_all('"', ''));
                      });
                      childrenAtt['functions'].push([imageCheckchild.val().smwpcb_replace_all('"', ''), imagedivs]);
                  } else {
                      childrenAtt['functions'].push(['0']);
                  }

                  if (videoCheckchild.is(':checked')) {
                      var videodivs = [];
                      $(this).find('.videodiv').each(function() {
                          videodivs.push($(this).find('.videodisplayurl').val().smwpcb_replace_all('"', ''));
                      });
                      childrenAtt['functions'].push([videoCheckchild.val().smwpcb_replace_all('"', ''), videodivs]);
                  } else {
                      childrenAtt['functions'].push(['0']);
                  }

                  if (checkrestore.attr('id') == 'usedefautrescheck') {
                      childrenAtt['triggers'] = [$(this).find('#keywordstriggers').val().smwpcb_replace_all('"', ''), $(this).find('#faqtriggers').val().smwpcb_replace_all('"', ''), $(this).find('#weight').val().smwpcb_replace_all('"', '')];
                  } else if (checkrestore.attr('id') == 'usefaqoptionscheck') {
                      childrenAtt['triggers'] = [$(this).find('#faqtriggers').val().smwpcb_replace_all('"', '')];
                  }

                  childrenAtt['responses'] = responses;
                  childrenAtt['restore'] = [checkrestorevarchild, checkedvarchild];

                  childrenAtt['elementID'] = $(this).attr('element-id');
                  inputCB['children'].push(childrenAtt);
              });

              if (inputCB['children'].length || i == 0) {
                  allofInputs.push(inputCB);
              }

            }
            var playground = $('div.treeGlb').html();
            var contruct_array = smwpcb_contruct_array_for_db();
            var data = {
                'action': 'smwpcb_generate_file',
                'chatbot_brain': [playground, contruct_array, allofInputs, idkey]
            };

            console.log(allofInputs);

            jQuery.post(smwpcb_custom_ui_topics_link.ajax_url, data, function(data) {
                $('.smwpcb_error_notice').attr('style', 'display: none;');
                $('.smwpcb_info_notice').attr('style', 'display: block;');
                $('.modal').attr('style', 'display:none');
                window.onbeforeunload = null;
                $("html, body").animate({
                    scrollTop: 0
                }, "slow");
            }).fail(function(jqXHR, textStatus, errorThrown) {
                $('.smwpcb_error_notice').text('Settings were not saved because of issue on your server: ' + errorThrown);
                $('.smwpcb_error_notice').attr('style', 'display: block;');
                $('.modal').attr('style', 'display:none');
                $("html, body").animate({
                    scrollTop: 0
                }, "slow");
            });

        } else {
            setTimeout(function() {
                $('.modal').attr('style', 'display:none');
                $('.smwpcb_info_notice').attr('style', 'display: none;');
                $('.smwpcb_error_notice').attr('style', 'display: block;');
                $("html, body").animate({
                    scrollTop: 0
                }, "slow");
            }, 500);
        }

    });

    wrapper.on('click', '.cbpanelzoom', function() {
      if ($(this).closest('.panelcb').css('zoom') == 1) {
          $(this).find('img').attr('src', smwpcb_custom_ui_topics_link.image_path + '/zoom-out.png');
          $(".tree").attr("style", "width:" + ($('.tree').width() + 700) + 'px');
          $(this).closest('.panelcb').animate({
              'zoom': 1.4
          }, 800);
          $('html, body').animate({
              scrollTop: $(this).closest('.panelcb').offset().top
          }, 1000);
      } else {
          $(this).find('img').attr('src', smwpcb_custom_ui_topics_link.image_path + '/zoom-in.png');
          $(this).closest('.panelcb').animate({
              'zoom': 1
          }, 800);
          $('html, body').animate({
              scrollTop: $('.tree').offset().top
          }, 1000);
          $(".tree").attr("style", "width:" + ($('.tree').width() - 700) + 'px');
      }

    });

    function smwpcb_display_errors_panel(element, ariaControl) {
      element.closest('.form-group').addClass('has-error');
      if (element.is('input') || element.attr('class').indexOf('descriptioncap') >=0 ) {
          if (element.attr('id') != 'keywordstriggers') {
              element.removeClass('borderbottombluecolorred');
              element.addClass('borderbottomredcolorred');
          } else {
              element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').removeClass('borderbottombluecolorredtag');
              element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').removeClass('borderbottomgreycolorred');
              element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').addClass('borderbottomredcolorred');
          }
      }
      if (!element.closest('.contact-form1').find(".smwpcb_disply_errors").find('.required_error').length) {
          element.closest('.contact-form1').find(".smwpcb_disply_errors").attr('style', 'display:block;');
          element.closest('.contact-form1').find(".smwpcb_disply_errors").append('<div class="required_error">Please set the required fields.</div>');
      }
      element.closest('.infom').find('li[aria-controls="' + ariaControl + '"]').addClass('redBackforvalidation');
      element.closest('.panelcb').find('.chatbotTools').addClass('redBackforvalidation');
    }

    function smwpcb_remove_errors_panel(element, ariaControl) {
      if (element.closest('.form-group').hasClass('has-error')) {
          element.closest('.form-group').removeClass('has-error');
          if (element.is('input') || element.attr('class').indexOf('descriptioncap') >=0 ) {
              if (element.attr('id') != 'keywordstriggers') {
                  element.removeClass('borderbottomredcolorred');
                  element.addClass('borderbottombluecolorred');
              } else {
                  element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').removeClass('borderbottombluecolorredtag');
                  element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').addClass('borderbottomgreycolorred');
                  element.closest('.keywordstrgsclass').find('.bootstrap-tagsinput').removeClass('borderbottomredcolorred');
              }
          }

      }

      if (!element.closest('.contact-form1').find(".has-error").length) {
          element.closest('.contact-form1').find(".required_error").remove();
      }
      if (!element.closest('.contact-form1').find(".smwpcb_disply_errors").children().length) {
          element.closest('.contact-form1').find(".smwpcb_disply_errors").attr('style', 'display:none;');
          element.closest('.infom').find('li[aria-controls="' + ariaControl + '"]').removeClass('redBackforvalidation');
      }
      if (!element.closest('.panelcb').find("li.redBackforvalidation").length) {
        element.closest('.panelcb').find('.chatbotTools').removeClass('redBackforvalidation');
      }

    }

    function smwpcb_stories_validation() {
      // add that users can't submit the playground without closing the discussion/topic.
      var valid = true;

      if ($('.treeGlb').find('.executableul').length == 1) {
          $('.smwpcb_error_notice').text('Settings were not saved, Please at least create one child panel');
          $('.smwpcb_error_notice').attr('style', 'display:block');
          valid = false;
      } else {
          $('.smwpcb_error_notice').text('Settings were not saved, Please correct the following red panels and try again.');
          $('.smwpcb_error_notice').attr('style', 'display:none');
      }

      wrapper.find('input[type="text"],input[type="url"],input[type="number"],textarea').each(function() {
          var arialabelledby = $(this).closest('.new_posts').attr('aria-labelledby');
          //One function task per message validation   
          //Chatbot tasks function validation   
          //add another case if one has been chosen, then remove has-error from others
          if ($(this).closest('.contact-form1').find('#displayprod').length) {
              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#displayprod').is(':checked') && ($(this).attr('class').indexOf('imageurl') >= 0 || $(this).attr('class').indexOf('linktocap') >= 0 || $(this).attr('class').indexOf('caption') >= 0 || $(this).attr('class').indexOf('descriptioncap') >= 0 || $(this).attr('class').indexOf('titlecap') >= 0) ) {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#displayprod').is(':checked')) && ($(this).attr('class').indexOf('imageurl') >= 0 || $(this).attr('class').indexOf('linktocap') >= 0 || $(this).attr('class').indexOf('caption') >= 0 || $(this).attr('class').indexOf('descriptioncap') >= 0 || $(this).attr('class').indexOf('titlecap') >= 0)) {
                  $(this).val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }

              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#imageCheck').is(':checked') && $(this).attr('class').indexOf('imagedisplayurl') >= 0 ){
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#imageCheck').is(':checked')) && $(this).attr('class').indexOf('imagedisplayurl') >= 0 ) {
                  $(this).val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }

              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#videoCheck').is(':checked') && $(this).attr('class').indexOf('videodisplayurl') >= 0 ) {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#videoCheck').is(':checked')) && $(this).attr('class').indexOf('videodisplayurl') >= 0 ) {
                  $(this).val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }

          } else if ($(this).closest('.contact-form1').find('#usedefautrescheck').length) {
              if ( smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#usedefautrescheck').is(':checked') && ($.inArray($(this).attr('id'), ['repeatTolerance', 'defaultresponse']) !== -1)) {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#usedefautrescheck').is(':checked')) && ($.inArray($(this).attr('id'), ['repeatTolerance', 'defaultresponse']) !== -1)) {
                  $(this).val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }

              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#storeusrmessage').is(':checked') && $(this).closest('.contact-form1').find('#usedefautrescheck').is(':checked') && $(this).attr('id') == 'storedmsguser') {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#storeusrmessage').is(':checked') || !$(this).closest('.contact-form1').find('#usedefautrescheck').is(':checked')) && $(this).attr('id') == 'storedmsguser') {
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }
              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).closest('.contact-form1').find('#storeusrmessagefaq').is(':checked') && $(this).attr('id') == 'storedmsguserfaq' && $(this).closest('.contact-form1').find('#usefaqoptionscheck').is(':checked')) {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if ((smwpcb_sanitize_text_field($(this).val()) != '' || !$(this).closest('.contact-form1').find('#storeusrmessagefaq').is(':checked') || !$(this).closest('.contact-form1').find('#usefaqoptionscheck').is(':checked')) && $(this).attr('id') == 'storedmsguserfaq') {
                  $(this).val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }
          } else {
              if (smwpcb_sanitize_text_field($(this).val()) == '' && $(this).attr('class') != 'smwpch_input_tags') {
                  $(this).val('');
                  smwpcb_display_errors_panel($(this), arialabelledby);
                  valid = false;
              } else if (smwpcb_sanitize_text_field($(this).val()) != '' && $(this).attr('class') != 'smwpch_input_tags') {
                  $(this).closest('.keywordstrgsclass').find('#keywordstriggers').val(smwpcb_sanitize_text_field($(this).val()));
                  smwpcb_remove_errors_panel($(this), arialabelledby);
              }
          }

      });

      wrapper.find('.infom').each(function() {
        if ($(this).closest('li.executable').find('ul.executableul').length == 0 && !$(this).find('#terminateTopicDest').is(':checked')) {
            if (!$(this).find('#terminateTopicDest').closest('.contact-form1').find(".frth_option_error").length)
                $(this).find('#terminateTopicDest').closest('.contact-form1').find(".smwpcb_disply_errors").append('<div class="frth_option_error">You must close the discussion or choose another topic, check the 4th option.</div>');
            $(this).find('#terminateTopicDest').closest('.contact-form1').find(".smwpcb_disply_errors").attr('style', 'display:block;');
            $(this).find('li[aria-controls="'+$(this).find('#terminateTopicDest').closest('.new_posts').attr('aria-labelledby')+'"]').addClass('redBackforvalidation');
            $(this).closest('.panelcb').find('.chatbotTools').addClass('redBackforvalidation');
            valid = false;
        } else if ($(this).closest('li.executable').find('ul.executableul').length == 0 && $(this).find('#terminateTopicDest').is(':checked') || $(this).closest('li.executable').find('ul.executableul').length) {
            if ($(this).find('#terminateTopicDest').closest('.contact-form1').find(".frth_option_error")) {
                $(this).find('#terminateTopicDest').closest('.contact-form1').find(".frth_option_error").remove();
            }
            if (!$(this).find('#terminateTopicDest').closest('.contact-form1').find(".smwpcb_disply_errors").children().length) {
                $(this).find('#terminateTopicDest').closest('.contact-form1').find(".smwpcb_disply_errors").attr('style', 'display:none;');
                $(this).find('li[aria-controls="'+$(this).find('#terminateTopicDest').closest('.new_posts').attr('aria-labelledby')+'"]').removeClass('redBackforvalidation');
            }
           if (!$(this).closest('.panelcb').find("li.redBackforvalidation").length) {
              $(this).closest('.panelcb').find('.chatbotTools').removeClass('redBackforvalidation');
            }
        }
      });
      return valid;
    }

    function smwpcb_notice_unsetted_res() {
      $(this).closest('.form-group').addClass('has-error');
      if ($(this).next().attr('class') != 'help-block smwpcb_required')
          $(this).after('<span class="help-block smwpcb_required">This field is required</span>');
      $(this).closest('.infom').find('li[aria-controls="tab_item-4"]').addClass('blueBackUnsetted');
      $(this).closest('.panelcb').find('.chatbotTools').addClass('redBackforvalidation');
    }

    function smwpcb_removeRedBackForValidation() {
      wrapper.find('input,textarea').each(function(){
        $(this).val(smwpcb_sanitize_text_field($(this).val()));
      });
    }

    function smwpcb_return_unsetted_responses(elementid) {
      for (var i = 0; i < smwpcb_intent_dialog_array_data.length; i++) {
          for (var j = 0; j < smwpcb_intent_dialog_array_data[i]['children'].length; j++) {
              if (smwpcb_intent_dialog_array_data[i]['children'][j]['elementID'] == elementid) {
                  return smwpcb_intent_dialog_array_data[i]['children'][j]['unset'];
              }
          }
      }
      return [];
    }

    function smwpcb_add_unsetted_trigger(elementkey, userResponse) {
        var data = {
            'action': 'smwpcb_add_unsetted_triggers_db',
            'data_added': [elementkey, userResponse, $('#smwpcb_topic_id_input').val()]
        };
        jQuery.post(smwpcb_custom_ui_topics_link.ajax_url, data);
    }

    function smwpcb_change_unsetted_triggers_div() {
        for (var elementkey in smwpcb_unsetted_triggers_array) {
            var UnsetedTriggersAdded = $('.infom[element-id="' + elementkey + '"]').find('#unsetedTriggers').html();
            var AddedString = '';
            for (var i = 0; i < smwpcb_unsetted_triggers_array[elementkey].length; i++) {
                if (i == 0) continue;
                AddedString += `
                                <div class="alert alert-info alert-dismissible" role="alert">
                                  <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span></button>
                                  ` + smwpcb_unsetted_triggers_array[elementkey][i].replace(/\\/g, '') + `
                                </div>
                              `;
            }
            if(UnsetedTriggersAdded == ''){
              $('.infom[element-id="' + elementkey + '"]').find('#unsetedTriggers').html('<div class="alert alert-info alert-dismissible" role="alert"><button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span></button>There\'s no unsolved users response yet.</div>');
            }
            if (AddedString !== UnsetedTriggersAdded) {
                $('.infom[element-id="' + elementkey + '"]').find('#unsetedTriggers').html(AddedString);
                if (smwpcb_unsetted_triggers_array[elementkey][0] == "0") {
                    if ($('.infom[element-id="' + elementkey + '"]').attr('parent-element') != "11") {
                        $('.infom[element-id="' + elementkey + '"]').find('li[aria-controls="tab_item-4"]').addClass('blueBackfornotification');
                    } else {
                        $('.infom[element-id="' + elementkey + '"]').find('li[aria-controls="tab_item-3"]').addClass('blueBackfornotification');
                    }
                    $('.infom[element-id="' + elementkey + '"]').closest('.panelcb').find('.chatbotTools').addClass("blueBackfornotification");
                } else {
                    if ($('.infom[element-id="' + elementkey + '"]').attr('parent-element') != "11") {
                        $('.infom[element-id="' + elementkey + '"]').find('li[aria-controls="tab_item-4"]').removeClass('blueBackfornotification');
                    } else {
                        $('.infom[element-id="' + elementkey + '"]').find('li[aria-controls="tab_item-3"]').removeClass('blueBackfornotification');
                    }
                    $('.infom[element-id="' + elementkey + '"]').closest('.panelcb').find('.chatbotTools').removeClass("blueBackfornotification");
                }
            }
        }
    }

    function smwpcb_solve_keywords_tags_suggest() {
      var tagsValues = '';

      wrapper.find('.infom').each(function() {
          $(this).find('.smwpcb_custom_tag').each(function() {
              tagsValues += smwpcb_sanitize_text_field($(this).text()) + ',';
          });
          $(this).find('.keywordstrgsclass').replaceWith('<div class="keywordstrgsclass"><input class="form-control" type="text" id="keywordstriggers" value="' + tagsValues + '" placeholder="add keywords here" data-role="tagsinput" autocomplete="off"/> </div>');
          $("input[data-role=tagsinput], select[multiple][data-role=tagsinput]").tagsinput();
          tagsValues = '';
      });

      wrapper.find('.dropdown.suggest').each(function() {
          $(this).remove();
      });

    }





    function smwpcb_solve_resort_options() {
      wrapper.find('.infom').each(function() {
          var toggleclass = $(this).find('.togglePanel');
          var dresToggle = $(this).find('.dresToggle');
          var terdestToggle = $(this).find('.terdestToggle');
          var faqToggle = $(this).find('.togglefaq');

          if ($(this).find('#resort_value').val() == '2') {
              toggleclass.attr('style', 'display:block');
              dresToggle.attr('style', 'display:none');
              terdestToggle.attr('style', 'display:none');
              faqToggle.attr('style', 'display:none');
              $(this).find('#restorevarscheck').prop('checked', true);
              $(this).find('#restorevarscheck').attr('checked', 'checked');
              $(this).find('#usefaqoptionscheck').prop('checked', false);
              $(this).find('#usefaqoptionscheck').removeAttr('checked');
              $(this).find('#terminateTopicDest').prop('checked', false);
              $(this).find('#terminateTopicDest').removeAttr('checked');
              $(this).find('#usedefautrescheck').prop('checked', false);
              $(this).find('#usedefautrescheck').removeAttr('checked');
          } else if ($(this).find('#resort_value').val() == '1') {
              toggleclass.attr('style', 'display:none');
              dresToggle.attr('style', 'display:block');
              terdestToggle.attr('style', 'display:none');
              faqToggle.attr('style', 'display:none');
              $(this).find('#usedefautrescheck').prop('checked', true);
              $(this).find('#usedefautrescheck').attr('checked', 'checked');

              $(this).find('#usefaqoptionscheck').prop('checked', false);
              $(this).find('#usefaqoptionscheck').removeAttr('checked');
              $(this).find('#terminateTopicDest').prop('checked', false);
              $(this).find('#terminateTopicDest').removeAttr('checked');
              $(this).find('#restorevarscheck').prop('checked', false);
              $(this).find('#restorevarscheck').removeAttr('checked');

          } else if ($(this).find('#resort_value').val() == '3') {
              toggleclass.attr('style', 'display:none');
              dresToggle.attr('style', 'display:none');
              terdestToggle.attr('style', 'display:none');
              faqToggle.attr('style', 'display:block');
              $(this).find('#usefaqoptionscheck').prop('checked', true);
              $(this).find('#usefaqoptionscheck').attr('checked', 'checked');

              $(this).find('#restorevarscheck').prop('checked', false);
              $(this).find('#restorevarscheck').removeAttr('checked');
              $(this).find('#terminateTopicDest').prop('checked', false);
              $(this).find('#terminateTopicDest').removeAttr('checked');
              $(this).find('#usedefautrescheck').prop('checked', false);
              $(this).find('#usedefautrescheck').removeAttr('checked');

          } else {
              toggleclass.attr('style', 'display:none');
              dresToggle.attr('style', 'display:none');
              terdestToggle.attr('style', 'display:block');
              faqToggle.attr('style', 'display:none');
              $(this).find('#terminateTopicDest').prop('checked', true);
              $(this).find('#terminateTopicDest').attr('checked', 'checked');

              $(this).find('#usefaqoptionscheck').prop('checked', false);
              $(this).find('#usefaqoptionscheck').removeAttr('checked');
              $(this).find('#restorevarscheck').prop('checked', false);
              $(this).find('#restorevarscheck').removeAttr('checked');
              $(this).find('#usedefautrescheck').prop('checked', false);
              $(this).find('#usedefautrescheck').removeAttr('checked');


          }
      });
    }

    function get_suggested_tags(element) {
        var suggestedItems = get_default_tags(element);
        var strReturned = '';
        for (var i = 0; i < suggestedItems.length; i++) {
            strReturned += '<li data-value="' + suggestedItems[i]['variable'] + '" class="' + ((i == 0) ? 'active' : '') + '"><a href="#"><strong>' + suggestedItems[i]['variable'] + '</strong> <small>' + suggestedItems[i]['action'] + '</small></a></li>';
        }
        return strReturned;
    }

    function get_default_tags(element) {
        var suggestedItems = [];
        var appendedObj = {};
        var displayprodAttr = element.closest('.infom').find('#displayprod').attr('checked');
        var googlesrchAttr = element.closest('.infom').find('#googlesrch').attr('checked');
        var imageCheckAttr = element.closest('.infom').find('#imageCheck').attr('checked');
        var videoCheckAttr = element.closest('.infom').find('#videoCheck').attr('checked');
        var restorevarsuggest = element.closest('.infom');
        while (restorevarsuggest.length) {
          var restorevarsuggestAttr = restorevarsuggest.find('#restorevarscheck').attr('checked');
          if ((typeof restorevarsuggestAttr !== typeof undefined && restorevarsuggestAttr !== false)) {
              if (smwpcb_data_tables_settings[restorevarsuggest.find('.restoredvar:checked').val()] != undefined) {
                  appendedObj = {};
                  appendedObj['variable'] = smwpcb_data_tables_settings[restorevarsuggest.find('.restoredvar:checked').val()]['variable'];
                  appendedObj['action'] = 'Users Data';
                  if (suggestedItems.indexOf(appendedObj) == -1) {
                      suggestedItems.push(appendedObj);
                  }
              }
          }
          restorevarsuggest = wrapper.find('.infom[element-id="' + restorevarsuggest.attr('parent-element') + '"]');
        }
        if ((typeof displayprodAttr !== typeof undefined && displayprodAttr !== false)) {
            suggestedItems.push({
                'variable': '+displayProducts',
                'action': 'Bot\'s Tasks'
            });
        }
        if ((typeof googlesrchAttr !== typeof undefined && googlesrchAttr !== false)) {
            suggestedItems.push({
                'variable': '+searchGoogle',
                'action': 'Bot\'s Tasks'
            });
        }
        if ((typeof imageCheckAttr !== typeof undefined && imageCheckAttr !== false)) {
            element.closest('.infom').find('.imagediv').each(function(diplayPhotoIndex) {
                suggestedItems.push({
                    'variable': '+diplayPhoto#' + (diplayPhotoIndex + 1),
                    'action': 'Bot\'s Tasks'
                });
            });
        }
        if ((typeof videoCheckAttr !== typeof undefined && videoCheckAttr !== false)) {
            element.closest('.infom').find('.videodiv').each(function(diplayVideoIndex) {
                suggestedItems.push({
                    'variable': '+diplayVideo#' + (diplayVideoIndex + 1),
                    'action': 'Bot\'s Tasks'
                });
            });
        }
        suggestedItems.push({
            'variable': '-lineBreak',
            'action': 'formating text'
        });
        suggestedItems.push({
            'variable': '-strong',
            'action': 'formating text'
        });
        suggestedItems.push({
            'variable': '-endStrong',
            'action': 'formating text'
        });
        return suggestedItems;
    }


    function disable_choice_restore(element) {
        element.closest('.panelcb').find('#usedefautrescheck').closest('.radio').addClass('disabledTarget');
        element.closest('.panelcb').find('#restorevarscheck').closest('.radio').addClass('disabledTarget');
        element.closest('.panelcb').find('#usefaqoptionscheck').closest('.radio').addClass('disabledTarget');
        element.closest('.panelcb').find('#terminateTopicDest').closest('.radio').addClass('disabledTarget');
    }

    function disable_unsetted_use_case(element) {
        element.closest('.panelcb').find('.smwpcb_mortarboard').attr('style', 'visibility: hidden');
    }

    function enable_unsetted_use_case(element) {
        element.closest('.panelcb').find('.smwpcb_mortarboard').attr('style', 'visibility: visible');
    }

    function enable_choice_restore(element) {
        element.find('#usedefautrescheck').closest('.radio').removeClass('disabledTarget');
        element.find('#restorevarscheck').closest('.radio').removeClass('disabledTarget');
        element.find('#usefaqoptionscheck').closest('.radio').removeClass('disabledTarget');
        element.find('#terminateTopicDest').closest('.radio').removeClass('disabledTarget');
    }

    // it can't target event click on a disabled input
    wrapper.on('click', 'input[disabled]', function(e) {
        $(this).prop('checked', false);
        e.preventDefault();
        alert('You can\'t edit these options once you created child topics, delete its children so you can edit them.');
    });

    $('.goBackToTopics').on('click', function() {
        $(location).attr('href', 'admin.php?page=smwpcb_wp_chatbot_topics');
    });

    $('.gotoToprojects').on('click', function() {
        $(location).attr('href', 'admin.php?page=smwpcb_wp_chatbot_projects');
    });

    function existingTag(text) {
      var existing = false,
          text = text.toLowerCase();

      $(".tags").each(function() {
          if ($(this).text().toLowerCase() == text) {
              existing = true;
              return "";
          }
      });

      return existing;
    }

    $(".tags-new input").focus();

    $(".tags-new input").keyup(function() {
        var tag = $(this).val().trim(),
            length = tag.length;
        if ((tag.charAt(length - 1) == ',') && (tag != ",")) {
            tag = tag.substring(0, length - 1);

            if (!existingTag(tag)) {
                $('<li class="tags"><span>' + tag + '</span><i class="fa fa-times"></i></i></li>').insertBefore($(".tags-new"));
                $(this).val("");
            } else {
                $(this).val(tag);
            }
        }
    });

    $(document).on("click", ".tags i", function() {
        $(this).parent("li").remove();
    });

    wrapper.on('focus', '.smwpch_input_tags', function() {
        if (!$(this).closest('.bootstrap-tagsinput').hasClass('borderbottomredcolorred'))
            $(this).closest('.bootstrap-tagsinput').addClass('borderbottombluecolorredtag');
    });

    wrapper.on('blur', '.borderbottombluecolorredtag', function() {
        $(this).closest('.bootstrap-tagsinput').removeClass('borderbottombluecolorredtag');
        $(this).closest('.bootstrap-tagsinput').addClass('borderbottomgreycolorred');
    });

    wrapper.on('click', '.expendTopic', function() {
        var selectedParent = $(this).attr('topic_token');
        $(this).attr('class', 'fas fa-angle-up reduceTopic');
        $(this).closest('.contact-form1').find('tr.' + selectedParent).attr('style', 'display: table-row;');
    });

    wrapper.on('click', '.reduceTopic', function() {
        var selectedParent = $(this).attr('topic_token');
        $(this).attr('class', 'fas fa-angle-down expendTopic');
        smwpcb_recursif_reduce(selectedParent, $(this).closest('.contact-form1'));
    });

    wrapper.on('click', '.close', function() {
        $(this).closest('.alert').remove();
    });

    wrapper.on('click', '#googlesrch', function(e) {
        if (smwpcb_chatbots_general_settings['smwpcb_google_custom_search_api_key'] == "" || smwpcb_chatbots_general_settings['smwpcb_google_custom_search_api_key'] == null) {
            alert("You can't allow Google Search API because you did't set up API key on the General Settings");
            $(this).prop('checked', false);
            e.preventDefault();
        }
    });

    function smwpcb_recursif_reduce(selectedParent, element) {
        element.find('tr.' + selectedParent).each(function() {
            var fasTopicToken = $(this).find('.fas').attr('topic_token');
            if (element.find('tr.' + fasTopicToken).length) {
                element.find('tr.' + fasTopicToken).attr('style', 'display: none;');
                element.find('tr.' + fasTopicToken).find('.reduceTopic').attr('class', 'fas fa-angle-down expendTopic');
            }
            $(this).attr('style', 'display: none;');
            $(this).find('.reduceTopic').attr('class', 'fas fa-angle-down expendTopic');
            smwpcb_recursif_reduce($(this).find('.fas').attr('topic_token'), element);
        });
    }

    function smwpcb_contruct_array_for_db() {
        var arrayToDb = [];
        wrapper.find('.infom').each(function() {
            var contrObj = {
                'topic_token': '',
                'firstmessage': '',
                'faqoptions': '',
                'typeTrigger': '',
                'topicparent': '',
                'restoreoption': ''
            };
            var responsesSpe = '';
            var restoreoption = '';
            var faq_triggers = smwpcb_faq_trigger($(this).attr('element-id'));
            contrObj['topic_token'] = $(this).attr('element-id');
            $(this).find('.botresponse').each(function(index) {
                if (index == 0)
                    responsesSpe += $(this).val();
                else
                    responsesSpe += '|6^9~' + $(this).val();
            });
            contrObj['firstmessage'] = responsesSpe;
            contrObj['faqoptions'] = faq_triggers[1].join("|6^9~");
            contrObj['typeTrigger'] = faq_triggers[0];
            contrObj['topicparent'] = $(this).attr('parent-element');
            if ($(this).find('#storeusrmessagefaq').is(':checked')) {
                restoreoption = 'yes';
                restoreoption += '|6^9~';
                restoreoption += $(this).find('#storedmsguserfaq').val();
            } else if ($(this).find('#storeusrmessage').is(':checked')) {
                restoreoption = 'yes';
                restoreoption += '|6^9~';
                restoreoption += $(this).find('#storedmsguser').val();
            } else {
                restoreoption = 'no';
            }
            contrObj['restoreoption'] = restoreoption;
            arrayToDb.push(contrObj);
        });
        return arrayToDb;

    }

    function smwpcb_faq_trigger(elementid) {
        var triggerfaq = [];
        var typeTrigger;
        if ($('.infom[parent-element="' + elementid + '"]').length) {
            $('.infom[parent-element="' + elementid + '"]').each(function() {
                if ($(this).find('#faqtriggers').length && !$(this).find('#keywordstriggers').length) {
                    triggerfaq.push($(this).find('#faqtriggers').val().smwpcb_replace_all('"', ''));
                    typeTrigger = "3";
                } else if ($(this).find('#faqtriggers').length && $(this).find('#keywordstriggers').length) {
                    triggerfaq.push($(this).find('#faqtriggers').val().smwpcb_replace_all('"', ''));
                    typeTrigger = "1";
                } else {
                    typeTrigger = "2";
                    return false;
                }
            });
            return [typeTrigger, triggerfaq];
        } else {
            return ["4", []];
        }
    }

    function smwpcb_display_topics_first_msg(topic_id, elementID, selectedValue) {
        var strg = '<tbody>';
        var data = {
            'action': 'smwpcb_retreive_all_subtopics',
            'topic_id': topic_id
        };
        if (topic_id !== $('#smwpcb_topic_id_input').val()) {

            jQuery.post(smwpcb_custom_ui_topics_link.ajax_url, data, function(data) {
                if (data != "") {
                    var arraydata = JSON.parse(data);
                    for (var i in arraydata) {
                        strg += '<tr class="' + arraydata[i]['topicparent'] + '" style="display:' + ((arraydata[i]['topicparent'] == '11' || arraydata[i]['topic_token'] == selectedValue) ? 'table-row' : 'none') + ';">';
                        strg += '<td><label><span class="smwpcb_switch_radio"><input type="radio" name="gotosubtopic' + elementID + '" class="gotosubtopic' + ((smwpcb_check_exists_parent(arraydata, arraydata[i]['topic_token']) == true) ? '' : ' disabledgotosubtopic') + '" value="' + ((i == 0) ? '11' : arraydata[i]['topic_token']) + '" ' + ((selectedValue == arraydata[i]['topic_token']) ? 'checked' : ((i == 0 && selectedValue == 'first') || (i == 0 && selectedValue == '11')) ? 'checked' : '') + '> <input type="hidden" value="' + arraydata[i]['firstmessage'] + '" class="firstmessagetopic"> <input type="hidden" value="' + arraydata[i]['faqoptions'] + '" class="faqoptionsdisplay"> <input type="hidden" value="' + arraydata[i]['typeTrigger'] + '" class="typeTrigger"> <input type="hidden" value="' + arraydata[i]['restoreoption'] + '" class="restoreoption"><i class="far fa-check-circle smwpcb_switch_radio_checked"></i><i class="far fa-circle smwpcb_switch_radio_unchecked"></i></span></label></td>';
                        strg += '<td>' + arraydata[i]['firstmessage'].split('|6^9~')[0].replace(/\\(.)/mg, "$1").replace(/^\s+|\s+$/g, ' ') + '</td>';
                        strg += '<td style="text-align: center;vertical-align: middle;">';
                        strg += '<i class="fas fa-angle-down ' + ((smwpcb_check_exists_parent(arraydata, arraydata[i]['topic_token']) == true) ? 'expendTopic' : '') + '" style="font-size: 22px;' + ((smwpcb_check_exists_parent(arraydata, arraydata[i]['topic_token']) == true) ? 'cursor:pointer;' : 'color:#ccc;') + '" topic_token="' + arraydata[i]['topic_token'] + '"></i>';
                        strg += '</td>';
                        strg += '</tr>';
                    }
                    strg += '</tbody>';
                    wrapper.find('.infom[element-id="' + elementID + '"]').find('.toggleTopics tbody').replaceWith(strg);
                }
            });
        } else {
            var arraydataPar = smwpcb_contruct_array_for_db();
            for (var j in arraydataPar) {
                strg += '<tr class="' + arraydataPar[j]['topicparent'] + '" style="display:' + ((arraydataPar[j]['topicparent'] == '11' || arraydataPar[j]['topic_token'] == selectedValue) ? 'table-row' : 'none') + ';">';
                strg += '<td><label><span class="smwpcb_switch_radio"><input type="radio" name="gotosubtopic' + elementID + '" class="gotosubtopic' + ((smwpcb_check_exists_parent(arraydataPar, arraydataPar[j]['topic_token']) == true) ? '' : ' disabledgotosubtopic') + '" value="' + ((j == 0) ? '11' : arraydataPar[j]['topic_token']) + '" ' + ((selectedValue == arraydataPar[j]['topic_token']) ? 'checked' : ((j == 0 && selectedValue == 'first') || (j == 0 && selectedValue == '11')) ? 'checked' : '') + '> <input type="hidden" value="' + arraydataPar[j]['firstmessage'] + '" class="firstmessagetopic"> <input type="hidden" value="' + arraydataPar[j]['faqoptions'] + '" class="faqoptionsdisplay"> <input type="hidden" value="' + arraydataPar[j]['typeTrigger'] + '" class="typeTrigger"> <input type="hidden" value="' + arraydataPar[j]['restoreoption'] + '" class="restoreoption"> <i class="far fa-check-circle smwpcb_switch_radio_checked"></i><i class="far fa-circle smwpcb_switch_radio_unchecked"></i></span></label></td>';
                strg += '<td>' + arraydataPar[j]['firstmessage'].split('|6^9~')[0].replace(/\\(.)/mg, "$1").replace(/^\s+|\s+$/g, ' ') + '</td>';
                strg += '<td style="text-align: center;vertical-align: middle;">';
                strg += '<i class="fas fa-angle-down ' + ((smwpcb_check_exists_parent(arraydataPar, arraydataPar[j]['topic_token']) == true) ? 'expendTopic' : '') + '" style="font-size: 22px;' + ((smwpcb_check_exists_parent(arraydataPar, arraydataPar[j]['topic_token']) == true) ? 'cursor:pointer;' : 'color:#ccc;') + '" topic_token="' + arraydataPar[j]['topic_token'] + '"></i>';
                strg += '</td>';
                strg += '</tr>';
            }
            strg += '</tbody>';
            wrapper.find('.infom[element-id="' + elementID + '"]').find('.toggleTopics tbody').replaceWith(strg);
        }
    }

    function smwpcb_check_exists_parent(arr, element) {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i]['topicparent'] == element)
                return true;
        }
        return false;
    }

    wrapper.on('click', '.disabledgotosubtopic', function(event) {
        $(this).prop('checked', false);
        $(this).removeAttr('checked');
        alert('You can\'t choose a topic that doesn\'t have descendents, please refesh if you had change it.');
        event.preventDefault();

    });

    wrapper.on('click', '.disabledTarget', function(event) {
        $(this).find('input').prop('checked', false);
        $(this).find('input').removeAttr('checked');
        alert('You can\'t change a target of a panel that have children, to change it you must delete all its children first.');
        event.preventDefault();

    });

  });

});