<?php
/**
 * @author    https://www.persianscript.ir
 * @link      https://www.persianscript.ir
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Add the chosen option from quick reply or user's 
 * reponses if using keywords.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_save_data_user_action')){

    function smwpcb_save_data_user_action() {

      $savedData = ( isset($_POST['savedData']) ) ? $_POST['savedData'] : ['',[]];
      $smwpcb_users_data_analytics_settings = smwpcb_retrieve_users_data_analytics($savedData[0]);
      foreach ($savedData[1] as $key => $savedDt) {
        if(($key+1)==count($savedData[1]))
          $smwpcb_users_data_analytics_settings['datauserschoice'] = $savedDt;
        else
          $smwpcb_users_data_analytics_settings[$key] = $savedDt;
      }
      var_dump($smwpcb_users_data_analytics_settings);
      smwpcb_update_users_data_analytics(serialize($smwpcb_users_data_analytics_settings), $savedData[0]);
      wp_die();

    }

}

/**
 * delete users entry by using id from the database 
 * smwpcb_users_data_analytics_settings.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_data_user_action')){

    function smwpcb_delete_data_user_action() {

      global $wpdb;
      $deleted_id = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
      $table_name  = $wpdb->prefix.'smwpcb_users_data_analytics_settings';
      $wpdb->query($wpdb->prepare("DELETE FROM $table_name WHERE id = %d",$deleted_id));
      wp_die();

    }

}

/**
 * Send the id of the updated project via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_get_updated_project')){

    function smwpcb_get_updated_project() {

      if(isset($_POST['project_id'])){
        $smwpcb_wp_chatbot_projects_settings = get_option('smwpcb_wp_chatbot_projects_settings');
        echo(json_encode($smwpcb_wp_chatbot_projects_settings[$_POST['project_id']]));
        wp_die();
      }

    }

}

/**
 * Send the id of the updated column data via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_get_updated_column')){

    function smwpcb_get_updated_column() {

      if(isset($_POST['column_id'])){
        $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
        echo(json_encode($smwpcb_data_tables_settings[$_POST['column_id']]));
        wp_die();
      }

    }

}

/**
 * Add value users entries via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_add_value_users_data_action')){

    function smwpcb_add_value_users_data_action() {

      if(isset($_POST['addedValue'])){
        global $wpdb;
        $table_name = $wpdb->prefix . 'smwpcb_users_data_analytics_settings';
        $query_results = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name WHERE uniquekey = %s",$_POST['addedValue'][2]));
        if(count($query_results) != 0) {
          $smwpcb_users_data_analytics_settings = smwpcb_retrieve_users_data_analytics($_POST['addedValue'][2]);
          $smwpcb_users_data_analytics_settings[intval($_POST['addedValue'][0])] = $_POST['addedValue'][1];
          $smwpcb_users_data_analytics_settings['date'] = date('m/d/Y h:i a');
          smwpcb_update_users_data_analytics(serialize($smwpcb_users_data_analytics_settings),$_POST['addedValue'][2]);
        }else{
          $smwpcb_users_data_analytics_settings = smwpcb_contruct_default_object();
          $smwpcb_users_data_analytics_settings[intval($_POST['addedValue'][0])] = $_POST['addedValue'][1];
          $smwpcb_users_data_analytics_settings['date'] = date('m/d/Y h:i a');
          smwpcb_add_users_data_analytics(serialize($smwpcb_users_data_analytics_settings), $_POST['addedValue'][2]);
        }
      }
      wp_die();

    }

}

/**
 * Add value users choice/reply via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_add_users_response_action')){

    function smwpcb_add_users_response_action() {

      if(isset($_POST['addedValue'])){
        global $wpdb;
        $table_name = $wpdb->prefix . 'smwpcb_users_data_analytics_settings';
        $query_results = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name WHERE uniquekey = %s",$_POST['addedValue'][2]));
        $strToAdd = "- ".$_POST['addedValue'][0] ." :\n";
        $strToAdd .= "**".$_POST['addedValue'][1] ."**\n";
        $emptyArr = smwpcb_contruct_default_object();
        if(count($query_results) != 0) {
          $smwpcb_users_data_analytics_settings = smwpcb_retrieve_users_data_analytics($_POST['addedValue'][2]);
          if($smwpcb_users_data_analytics_settings['datauserschoice'] == 'Empty')
            $smwpcb_users_data_analytics_settings['datauserschoice'] = '';
          $smwpcb_users_data_analytics_settings['datauserschoice'] = $smwpcb_users_data_analytics_settings['datauserschoice'].$strToAdd;
          $smwpcb_users_data_analytics_settings['date'] = date('m/d/Y h:i a');
          smwpcb_update_users_data_analytics(serialize($smwpcb_users_data_analytics_settings),$_POST['addedValue'][2]);
        }else{
          $smwpcb_users_data_analytics_settings = $emptyArr;
          $smwpcb_users_data_analytics_settings['datauserschoice'] = $strToAdd;
          $smwpcb_users_data_analytics_settings['date'] = date('m/d/Y h:i a');
          smwpcb_add_users_data_analytics(serialize($smwpcb_users_data_analytics_settings), $_POST['addedValue'][2]);
        }
      }
      wp_die();

    }

}

/**
 * Delete chatbot's agent profile ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_agent_action')){

    function smwpcb_delete_agent_action() {

      $smwpcb_wp_chatbot_agents_settings = get_option('smwpcb_wp_chatbot_agents_settings');
      $deleted_id = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
      unset($smwpcb_wp_chatbot_agents_settings[$deleted_id]);
      update_option('smwpcb_wp_chatbot_agents_settings', $smwpcb_wp_chatbot_agents_settings);
      wp_die();

    }

}

/**
 * Delete a project via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_project_action')){

    function smwpcb_delete_project_action() {

      $smwpcb_wp_chatbot_projects_settings = get_option('smwpcb_wp_chatbot_projects_settings');
      $deleted_id = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
      unset($smwpcb_wp_chatbot_projects_settings[$deleted_id]);
      update_option('smwpcb_wp_chatbot_projects_settings', $smwpcb_wp_chatbot_projects_settings);
      wp_die();

    }

}

/**
 * Delete data column via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_column_action')){

    function smwpcb_delete_column_action() {

      $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
      $deleted_id = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
      unset($smwpcb_data_tables_settings[$deleted_id]);
      update_option('smwpcb_data_tables_settings', $smwpcb_data_tables_settings);
      wp_die();
    }

}

/**
 * Delete a topic via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_topic_action')){

    function smwpcb_delete_topic_action() {

      $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
      $deleted_id = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
      unset($smwpcb_wp_chatbot_topics_settings[$deleted_id]);
      update_option('smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings);
      smwpcb_delete_topic_from_db($deleted_id);
      if(file_exists(SMWPCB_PLUGIN_DIR."brain/topic".$deleted_id.".rive")){
        unlink(SMWPCB_PLUGIN_DIR."brain/topic".$deleted_id.".rive");
      }
      smwpcb_merge_files();
      wp_die();

    }

}

/**
 * Delete multiple topics at once via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_apply_topic_action')){

    function smwpcb_delete_apply_topic_action() {

      $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
      $deleted_keys = ( isset($_POST['deleted_keys']) ) ? $_POST['deleted_keys'] : '';
      for ($i=0; $i <count($deleted_keys) ; $i++) {
        if(array_key_exists($deleted_keys[$i], $smwpcb_wp_chatbot_topics_settings)){
          unset($smwpcb_wp_chatbot_topics_settings[$deleted_keys[$i]]);
          smwpcb_delete_topic_from_db($deleted_keys[$i]);
          if(file_exists(SMWPCB_PLUGIN_DIR."brain/topic".$deleted_keys[$i].".rive")){
            unlink(SMWPCB_PLUGIN_DIR."brain/topic".$deleted_keys[$i].".rive");
          }
        }
      }
      update_option('smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings);
      smwpcb_merge_files();
      wp_die();

    }

}

/**
 * Delete multiple topics at once via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_apply_user_data_action')){

    function smwpcb_delete_apply_user_data_action() {

      global $wpdb;
      $table_name  = $wpdb->prefix.'smwpcb_users_data_analytics_settings';
      $deleted_keys = ( isset($_POST['deleted_keys']) ) ? $_POST['deleted_keys'] : '';
      for ($i=0; $i <count($deleted_keys) ; $i++) {
        $wpdb->query($wpdb->prepare("DELETE FROM $table_name WHERE id = %d",$deleted_keys[$i]));
      }
      wp_die();

    }

}

/**
 * Delete multiple projects at once via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_apply_project_action')){

    function smwpcb_delete_apply_project_action() {

        $smwpcb_wp_chatbot_projects_settings = get_option('smwpcb_wp_chatbot_projects_settings');
        $deleted_keys = ( isset($_POST['deleted_keys']) ) ? $_POST['deleted_keys'] : '';
        for ($i=0; $i <count($deleted_keys) ; $i++) {
          if(array_key_exists($deleted_keys[$i], $smwpcb_wp_chatbot_projects_settings)){
            unset($smwpcb_wp_chatbot_projects_settings[$deleted_keys[$i]]);
          }
        }
        update_option('smwpcb_wp_chatbot_projects_settings', $smwpcb_wp_chatbot_projects_settings);
        wp_die();

    }

}

/**
 * Delete multiple columns data at once via ajax request.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_apply_column_table_action')){

    function smwpcb_delete_apply_column_table_action() {

        $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
        $deleted_keys = ( isset($_POST['deleted_keys']) ) ? $_POST['deleted_keys'] : '';
        for ($i=0; $i <count($deleted_keys) ; $i++) {
          if(array_key_exists($deleted_keys[$i], $smwpcb_data_tables_settings)){
            unset($smwpcb_data_tables_settings[$deleted_keys[$i]]);
          }
        }
        update_option('smwpcb_data_tables_settings', $smwpcb_data_tables_settings);
        wp_die();
    }

}

/**
 * Add unsolved users answers to train the chatbot
 * to the option smwpcb_unsetted_response_triggers.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_add_unsetted_triggers_db')){

    function smwpcb_add_unsetted_triggers_db() {

        $smwpcb_unsetted_response_triggers = get_option('smwpcb_unsetted_response_triggers');
        $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
        $data_added = ( isset($_POST['data_added']) ) ? $_POST['data_added'] : [];
        $smwpcb_wp_chatbot_topics_settings[intval($data_added[2])]['smwpcb_topic_unsetted']="1";
        update_option('smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings);
        $found = false;
        foreach ($smwpcb_unsetted_response_triggers as $keyElement => $response_trigger) {
          if($keyElement == $data_added[0]){
            array_push($smwpcb_unsetted_response_triggers[$keyElement], $data_added[1]);
            $smwpcb_unsetted_response_triggers[$keyElement][0] = "0";
            $found = true;
          }
        }
        if(!$found){
          $smwpcb_unsetted_response_triggers[$data_added[0]] = array(0=>'0',1=>$data_added[1]);
        }
        update_option('smwpcb_unsetted_response_triggers', $smwpcb_unsetted_response_triggers);
        wp_die();

    }

}

/**
 * Delete unsolved users answers to train the chatbot
 * from the option smwpcb_unsetted_response_triggers.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_remove_unsetted_triggers_db')){

    function smwpcb_remove_unsetted_triggers_db() {

        $smwpcb_unsetted_response_triggers = get_option('smwpcb_unsetted_response_triggers');
        $data_added = ( isset($_POST['data_added']) ) ? $_POST['data_added'] : [];

        $smwpcb_unsetted_response_triggers[$data_added[0]][0] = "1";
        if($data_added[1]=='0'){
          $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
          $smwpcb_wp_chatbot_topics_settings[intval($data_added[2])]['smwpcb_topic_unsetted']="0";
          update_option('smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings);
        }

        update_option('smwpcb_unsetted_response_triggers', $smwpcb_unsetted_response_triggers);
        wp_die();
    }

}

/**
 * This function handle user interface of the
 * widget and its customization.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_cb_ui_custom_action')){

    function smwpcb_cb_ui_custom_action() {

        smwpcb_contruct_ui_settings($_POST['postedData']);
        smwpcb_modify_ui_cb_style_file($_POST['postedData']);
        wp_die();

    }

}


/**
 * Add code licence action
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_add_code_licence_action')){

    function smwpcb_add_code_licence_action() {

        $smwpcb_wp_chatbot_code_licence_settings = get_option('smwpcb_wp_chatbot_code_licence_settings');
        $itemkeys = ( isset($_POST['itemkeys']) ) ? $_POST['itemkeys'] : '';
        $smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence']['smwpcb_code_licence'.$itemkeys] = '';
        update_option('smwpcb_wp_chatbot_code_licence_settings', $smwpcb_wp_chatbot_code_licence_settings);
        wp_die();
    }

}

/**
 * Delete code licence action
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_delete_code_licence_action')){

    function smwpcb_delete_code_licence_action() {

        $smwpcb_wp_chatbot_code_licence_settings = get_option('smwpcb_wp_chatbot_code_licence_settings');
        $deleted_key = ( isset($_POST['deleted_key']) ) ? $_POST['deleted_key'] : '';
        unset($smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence']['smwpcb_code_licence'.$deleted_key]);
        update_option('smwpcb_wp_chatbot_code_licence_settings', $smwpcb_wp_chatbot_code_licence_settings);
        wp_die();
    }

}

/**
 * Rate the plugin action
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_rate_the_plugin_action')){

    function smwpcb_rate_the_plugin_action() {
        global $current_user;
        $smwpcb_maxbot_additional_settings = get_option('smwpcb_maxbot_additional_settings');
        $rate = ( isset($_POST['rate']) ) ? $_POST['rate'] : '';
        $smwpcb_maxbot_additional_settings['smwpcb_user_rating'] = $rate;
        update_option('smwpcb_maxbot_additional_settings', $smwpcb_maxbot_additional_settings);
        get_currentuserinfo();
        $email = (string) $current_user->user_email;
        wp_mail( 'sarahamiliac@gmail.com', 'User Rating', 'User: '.$email.' Rate: '.$rate );
        wp_die();
    }

}


/**
 * Ajax action.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_verify_review_code_licence')){

    function smwpcb_verify_review_code_licence() {

        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_URL => "https://api.envato.com/v3/market/catalog/item?id=25237469",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_TIMEOUT => 20,
            
            CURLOPT_HTTPHEADER => array(
                "Authorization: Bearer f633Uur723aEJel0z5FK09q4Lut1BmRx",
                "User-Agent: I will later"
            )
        ));
        $smwpcb_plugin_rating_options = get_option('smwpcb_plugin_rating_options');
        $response = @curl_exec($ch);
        if (curl_errno($ch) > 0) 
            echo( "Failed of code to query Envato API: ");
        $responseCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        if ($responseCode === 404) 
            echo("The purchase code was invalid.");
        if ($responseCode !== 200) 
            echo("Failed to validate code due to an error: HTTP {$responseCode}.");
        $body = json_decode($response);
        if($current_review[0] !== false && $smwpcb_plugin_rating_options[1] < $body->rating_count && $smwpcb_plugin_rating_options[2] < $body->rating){
            $smwpcb_plugin_rating_options = array(3, $body->rating_count, $body->rating);
            update_option('smwpcb_plugin_rating_options', $smwpcb_plugin_rating_options);
            echo("true");
        }else{
            $smwpcb_plugin_rating_options = array(4, $body->rating_count, $body->rating);
            update_option('smwpcb_plugin_rating_options', $smwpcb_plugin_rating_options);
            echo("false");
        }
        wp_die();

    }

}

/**
 * Ajax action.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_start_review_code_licence')){

    function smwpcb_start_review_code_licence(){
        $current_review = smwpcb_get_current_review_system();
        update_option('smwpcb_plugin_rating_options', array(2, $current_review[1], $current_review[2]));
        echo("true");
        wp_die();
    }

}







?>