<?php
/**
 * @author    https://www.persianscript.ir
 * @link      https://www.persianscript.ir
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Adding, editing and deleting chatbot's project page option.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_project_options')){

    function smwpcb_wp_chatbot_project_options() {
      $smwpcb_wp_chatbot_projects_settings = get_option('smwpcb_wp_chatbot_projects_settings');
      $smwpcb_wp_chatbot_agents_settings = get_option('smwpcb_wp_chatbot_agents_settings');
      $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
      $smwpcb_plugin_rating_options = get_option('smwpcb_plugin_rating_options');
      //$smwpcb_wp_code_licence_empower = smwpcb_wp_code_licence_empower();

      //if($smwpcb_wp_code_licence_empower[0] > count($smwpcb_wp_chatbot_projects_settings)){
        if (isset($_POST['page_chatbots_projects']) && check_admin_referer(plugin_basename(__FILE__), 'chatbots_projects_admin_referer')) {
          $wp_chatbot = array();
          $wp_chatbot['smwpcb_chatbot_project_name'] = (isset($_POST['smwpcb_chatbot_project_name'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_name']) : '';
          $wp_chatbot['smwpcb_chatbot_project_topic'] = (isset($_POST['smwpcb_chatbot_project_topic'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_topic']) : '';
          $wp_chatbot['smwpcb_chatbot_project_agent'] = (isset($_POST['smwpcb_chatbot_project_agent'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_agent']) : '';
          $wp_chatbot['smwpcb_chatbot_project_widget_page'] = (isset($_POST['smwpcb_chatbot_project_widget_page'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_widget_page']) : '';

          $wp_chatbot['smwpcb_chatbot_project_shortcode'] = (isset($_POST['smwpcb_chatbot_project_shortcode'])) ? $_POST['smwpcb_chatbot_project_shortcode'] : 'No';

          $wp_chatbot['smwpcb_chatbot_project_shortcode_code'] = uniqid();

          $wp_chatbot['smwpcb_chatbot_project_last_modified'] = date('m/d/Y h:i a');
          array_push($smwpcb_wp_chatbot_projects_settings, $wp_chatbot);
          update_option( 'smwpcb_wp_chatbot_projects_settings', $smwpcb_wp_chatbot_projects_settings );
        }
        if(isset($_POST['edit_page_chatbots_projects']) && isset($_POST['smwpcb_edit_project_key'])){
          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_name'] = (isset($_POST['smwpcb_chatbot_project_name'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_name']) : '';
          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_topic'] = (isset($_POST['smwpcb_chatbot_project_topic'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_topic']) : '';
          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_agent'] = (isset($_POST['smwpcb_chatbot_project_agent'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_agent']) : '';
          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_widget_page'] = (isset($_POST['smwpcb_chatbot_project_widget_page'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_widget_page']) : '';

          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_shortcode'] = (isset($_POST['smwpcb_chatbot_project_shortcode'])) ? sanitize_text_field($_POST['smwpcb_chatbot_project_shortcode']) : 'No';

          if(!array_key_exists('smwpcb_chatbot_project_shortcode', $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]) || $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_shortcode_code'] == ''){
            $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_shortcode_code'] = uniqid();
          }

          $smwpcb_wp_chatbot_projects_settings[$_POST['smwpcb_edit_project_key']]['smwpcb_chatbot_project_last_modified'] = date('m/d/Y h:i a');
          update_option( 'smwpcb_wp_chatbot_projects_settings', $smwpcb_wp_chatbot_projects_settings );
        }
      //}
      ?>
      <div class="wrap">
      <h1 class="wp-heading-inline"><?php esc_html_e('Projects', 'smart-wordpress-chatbot'); ?></h1>
      </div>
      <?php
      if($smwpcb_wp_code_licence_empower[0] > count($smwpcb_wp_chatbot_projects_settings)){
      ?>
        <button type="button" id="add_new_agent" class="page-title-action"><?php esc_html_e('Add New', 'smart-wordpress-chatbot'); ?></button>
      <?php
      }
      ?>
      <div id="addmoreproject" class="addmoreprAg">
      <form action="" method="post">
      <table class="form-table">
      <tbody>
        <tr>
          <th scope="row"><label for="smwpcb_chatbot_project_name"><?php esc_html_e('Project Name', 'smart-wordpress-chatbot'); ?></label></th>
          <td>
              <input type="text" id="smwpcb_chatbot_project_name" name="smwpcb_chatbot_project_name" required />
              <p class="description"><?php esc_html_e('Make a name for the project.', 'smart-wordpress-chatbot'); ?></p>
          </td>
        </tr>
        <tr>
            <th scope="row"><label for="smwpcb_chatbot_project_topic"><?php esc_html_e('Topic Starter', 'smart-wordpress-chatbot'); ?></label></th>
            <td>
              <?= smwpcb_get_all_the_topics("smwpcb_chatbot_project_topic","smwpcb_chatbot_project_topic") ?>
                <p class="description"><?php esc_html_e('Choose the topic the chatbot will start with.', 'smart-wordpress-chatbot'); ?></p>
            </td>
        </tr>
        <tr>
            <th scope="row"><label for="smwpcb_chatbot_project_agent"><?php esc_html_e('Corresponding Agent', 'smart-wordpress-chatbot'); ?></label></th>
            <td>
                <?= smwpcb_get_all_the_agents("smwpcb_chatbot_project_agent", "smwpcb_chatbot_project_agent") ?>
                <p class="description"><?php esc_html_e('Choose the agent of the chatbot.', 'smart-wordpress-chatbot'); ?></p>
            </td>
        </tr>
        <tr class="smwpcb_widget_descendent">
            <th scope="row"><label for="smwpcb_chatbot_project_widget_page"><?php esc_html_e('Specify page', 'smart-wordpress-chatbot'); ?></label></th>
            <td>
              <?= smwpcb_get_all_the_pages("smwpcb_chatbot_project_widget_page", "smwpcb_chatbot_project_widget_page",$smwpcb_wp_chatbot_projects_settings) ?>
                <p class="description"><?php esc_html_e('specify which page to include the widget.', 'smart-wordpress-chatbot'); ?></p>
            </td>
        </tr>
        <tr>
            <th scope="row"><label for="smwpcb_chatbot_project_shortcode"><?php _e('Shortcode', 'smart-wordpress-chatbot'); ?></label></th>
            <td>
              <label class="smwpcb_switch_toggle">
                <input type="checkbox" id="smwpcb_chatbot_project_shortcode" name="smwpcb_chatbot_project_shortcode" value="Yes" />
                <div class="smwpcb_toggle round"></div>
              </label>
              <p class="description"><?php _e('Use shortcode only if for some reason the widget didn\'t get integrated on the specified page.', 'smart-wordpress-chatbot'); ?></p>
            </td>
        </tr>
      </tbody>
      </table>
      <p class="submit">
          <button type="button" class="button cancelsubmit" id="cancelagentsubmit"><?php esc_html_e('Cancel', 'smart-wordpress-chatbot'); ?></button>
          <input type="submit" class="button-primary" id="addprojectsubmit" value="<?php esc_html_e('Add Project', 'smart-wordpress-chatbot') ?>" />
          <input type="hidden" name="page_chatbots_projects" value="submit" />
          <?php wp_nonce_field(plugin_basename(__FILE__), 'chatbots_projects_admin_referer'); ?>
      </p>
      </form>
      </div>
      <div class="tablenav top">
        <div class="alignleft actions bulkactions">
            <label for="bulk-action-selector-top" class="screen-reader-text"><?php esc_html_e('Select bulk action', 'smart-wordpress-chatbot'); ?></label>
            <select name="action" id="bulk-action-selector-top">
                <option value=""><?php esc_html_e('Bulk Actions', 'smart-wordpress-chatbot'); ?></option>
                <option value="delete-selected-project"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></option>
            </select>
            <input type="submit" class="button" id="applyChatBotProject" value="<?php esc_html_e('Apply', 'smart-wordpress-chatbot'); ?>">
        </div>
      </div>
        <table class="smwpcb_table_fix widefat striped smwpcb_users_data">
          <thead>
              <tr>
                  <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                      <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
                      <input id="cb-select-all-1" type="checkbox" value="">
                  </td>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Project Name', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Widget', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Topic Starter', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Agent', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Last Modified', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
              </tr>
          </thead>
          <tbody id="the-list">
            <?php
              if(count($smwpcb_wp_chatbot_projects_settings) == 0){
                echo('<tr><td class="row-title" colspan="7">');
                esc_html_e('There\'s no chatbot projets', 'smart-wordpress-chatbot');
                echo('</td></tr>');
              }else{
                foreach ($smwpcb_wp_chatbot_projects_settings as $key => $project_settings) {
                  ?>
                  <tr>
                  <th scope="row" class="check-column smwpcb_column_fix">
                      <input type="checkbox" class="checkedProject" value="<?= $key ?>">
                  </th>
                  <td class="column-primary">
                    <strong><a href="javascript:void(0)" key="<?= $key ?>" class="updatecbproject"><?= esc_html(stripslashes($project_settings['smwpcb_chatbot_project_name']))?></a></strong>
                      <div class="row-actions">
                        <span class="edit">
                          <a href="javascript:void(0)" key="<?= $key ?>" class="updatecbproject"><?php esc_html_e('Edit', 'smart-wordpress-chatbot'); ?></a> | </span>
                        <span class="trash">
                          <a href="javascript:void(0)" key="<?= $key ?>" class="deletecbproject"><?php esc_html_e('Trash', 'smart-wordpress-chatbot'); ?></a> </span>
                      </div>
                  </td>
                  <td>
                  <?= esc_html(stripslashes($project_settings['smwpcb_chatbot_project_widget'])) ?>
                  </td>
                  <td class="column-shortcode smwpcb_adjust_flow">
                  <?php
                  
                  if(array_key_exists('smwpcb_chatbot_project_shortcode', $project_settings) && $project_settings['smwpcb_chatbot_project_shortcode'] == 'Yes'){
                    echo("<div style='text-align:center;'> The shortcode for <a target='_blank' href='".get_page_link(esc_attr($project_settings['smwpcb_chatbot_project_widget_page']))."'>".get_the_title(esc_html(stripslashes($project_settings['smwpcb_chatbot_project_widget_page'])))."</a> is: <br>
                      <input type='text' value='[maxbot-chatbot-builder project=\"".$project_settings['smwpcb_chatbot_project_shortcode_code']."\"]' style='width: 200px; font-size: 12px;' readonly='' onclick='jQuery(this).select();'></div>");
                  }else{
                    esc_html_e('Integrated on ', 'smart-wordpress-chatbot');
                    echo("<a target='_blank' href='".get_page_link(esc_attr($project_settings['smwpcb_chatbot_project_widget_page']))."'>".get_the_title(esc_html(stripslashes($project_settings['smwpcb_chatbot_project_widget_page'])))."</a>");
                  }
                  ?>
                  </td>
                  <td>
                  <?= esc_html(stripslashes($smwpcb_wp_chatbot_topics_settings[$project_settings['smwpcb_chatbot_project_topic']]['smwpcb_topic_name']))?>
                  </td>
                  <td>
                  <?= esc_html(stripslashes($smwpcb_wp_chatbot_agents_settings[$project_settings['smwpcb_chatbot_project_agent']]['chatbots_name'])) ?>
                  </td>
                  <td>
                    <?= esc_html($project_settings['smwpcb_chatbot_project_last_modified']) ?>
                  </td>
                      
                  </tr>
                  <?php
                }
              }
            ?>
          </tbody>
          <tfoot>
            <tr>
              <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
                <input id="cb-select-all-1" type="checkbox" value="">
              </td>
              <th scope="col" class="manage-column sortable desc">
                <a href="javascript:void(0)"><span><?php esc_html_e('Project Name', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a>
              </th>
              <th scope="col" class="manage-column sortable desc">
                <a href="javascript:void(0)"><span><?php esc_html_e('Widget', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
              </th>
              <th scope="col" class="manage-column sortable desc"></th>
              <th scope="col" class="manage-column sortable desc">
                <a href="javascript:void(0)"><span><?php esc_html_e('Topic Starter', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
              </th>
              <th scope="col" class="manage-column sortable desc">
                <a href="javascript:void(0)"><span><?php esc_html_e('Agent', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
              </th>
              <th scope="col" class="manage-column sortable desc">
                <a href="javascript:void(0)"><span><?php esc_html_e('Last Modified', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
              </th>
            </tr>
          </tfoot>
        </table>
      </div>
     <?php

    }

}


?>