<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Print out the available data columns.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_display_data_columns')){

	function smwpcb_display_data_columns($randomTopic,$rank){

	  $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
	  $strg = '';
    for ($i = 0; $i < count($smwpcb_data_tables_settings); $i++) {
      $strg .= '<tr>';
      $strg .= '<td><label><span class="smwpcb_switch_radio"><input type="radio" name="'.$randomTopic.'" class="restoredvar" value="'.$i.'" '.(($i==$rank)?'checked':'').'><i class="far fa-check-circle smwpcb_switch_radio_checked"></i><i class="far fa-circle smwpcb_switch_radio_unchecked"></i></span></label>';
      $strg .= '<input type="hidden" value="'.esc_html($smwpcb_data_tables_settings[$i]['column_validation']).'" class="validationinput">';
      $strg .= '<input type="hidden" value="'.esc_html($smwpcb_data_tables_settings[$i]['column_validation_msg']).'" class="validationmsginput"> </td>';
      $strg .= '<td>'.esc_html($smwpcb_data_tables_settings[$i]['name']).'</td>';
      $strg .= '<td>'.esc_html($smwpcb_data_tables_settings[$i]['variable']).'</td>';
      $strg .= '</tr>';
    }
	  return $strg;

	}

}

/**
 * Print out the available blocks on a certain topic.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_display_dest_topic')){

	function smwpcb_display_dest_topic($idTopic){

	  $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
	  $strg = '<select class="form-control closedDiscussion">';
	  $strg .= "<option value='closeDisc' ".(($idTopic == 0)?"selected='selected' ":"").">Close Discussion</option>";
	  for ($i = 0; $i < count($smwpcb_wp_chatbot_topics_settings); $i++) {
	    $strg .= "<option value='".$smwpcb_wp_chatbot_topics_settings[$i]['smwpcb_topic_id']."' ".((($i+1)==$idTopic)? "selected='selected' ":"").">";
	    $strg .= esc_html($smwpcb_wp_chatbot_topics_settings[$i]['smwpcb_topic_name']);
	    $strg .= "</option>";
	  }
	  $strg .= '</select>';
	  return $strg;

	}

}

/**
 * Verify if a certain block exists on a certain topic.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_verify_exists')){

	function smwpcb_verify_exists($val, $arr){

    for ($i=0; $i < count($arr); $i++) {
      if($val == $arr[$i]['elementID'])
        return true;
    }
    return false;

	}

}

/**
 * Get all data columns variables.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_get_all_table_columns_variables')){

	function smwpcb_get_all_table_columns_variables(){

	    $arr = array();
	    $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
	    for ($i=0; $i < count($smwpcb_data_tables_settings); $i++) {
	        array_push($arr, $smwpcb_data_tables_settings[$i]['variable']);
	    }
	    return $arr;

	}

}

/**
 * Add users restored variables.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_users_restored_vars')){

	function smwpcb_users_restored_vars(){

    $arr = array();
    $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
    for ($i=0; $i < sizeof($smwpcb_data_tables_settings); $i++) {
        array_push($arr, 'undefined');
    }
    return $arr;

	}

}

/**
 * Get all the data columns name.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_get_all_table_columns_name')){

	function smwpcb_get_all_table_columns_name(){

	    $arr = array();
	    $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
	    for ($i=0; $i < count($smwpcb_data_tables_settings); $i++) {
	        array_push($arr, $smwpcb_data_tables_settings[$i]['name']);
	    }
	    return $arr;

	}

}

/**
 * Construct a default object for users entries.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_contruct_default_object')){

	function smwpcb_contruct_default_object(){

	    $arr = array();
	    $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
	    for ($i=0; $i < count($smwpcb_data_tables_settings); $i++) {
	        array_push($arr, 'Empty');
	    }
	    $arr['datauserschoice'] = 'Empty';
	    return $arr;

	}

}

/**
 * Get all available topics.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_all_the_topics')){

  function smwpcb_get_all_the_topics($input_name,$input_id){

    $topics = get_option('smwpcb_wp_chatbot_topics_settings');
    $select = '<select name="'. $input_name .'" ';
    $select .= 'id="'. $input_id .'" required';
    $select .= '><option value="">- Select Topic -</option>';
    foreach ( $topics as $topic ){
      $option = '<option value="' . $topic['smwpcb_topic_id'] . '">';
      $option .= stripslashes(esc_html($topic['smwpcb_topic_name']));
      $option .= '</option>';
      $select .= $option;
    }
    $select .= '</select>';
    return $select;

  }

}

/**
 * Get all avaibles the agents.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_all_the_agents')){

  function smwpcb_get_all_the_agents($input_name,$input_id){

    $agents = get_option('smwpcb_wp_chatbot_agents_settings');
    $select = '<select name="'. $input_name .'" ';
    $select .= 'id="'. $input_id .'" required';
    $select .= '><option value="">- Select Agent -</option>';
    foreach ( $agents as $key => $agent ){
      $option = '<option value="' . $key . '">';
      $option .= stripslashes(esc_html($agent['chatbots_name'])); 
      $option .= '</option>';
      $select .= $option;
    }
    $select .= '</select>'; 
    return $select;

  }

}

/**
 * Get all avaibles the pages and posts.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_all_the_pages')){

    function smwpcb_get_all_the_pages( $input_name, $input_id,$projects_settings) {

      $pageTakenIds = array();
      foreach ($projects_settings as $project) {
      	array_push($pageTakenIds, $project['smwpcb_chatbot_project_widget_page']);
      }
      $pages = get_pages(
                array(
                    'sort_order' => 'asc',
                    'sort_column' => 'post_title',
                )
              );
      $posts = get_posts(
                array(
                    'order' => 'ASC',
                    'orderby' => 'title',
                )
              );
      $select = '<select name="'. $input_name .'" ';
      $select .= 'id="'. $input_id .'" required>';
      $select .= '<option value="">- Select Page or Post -</option>';
      $select .= '<optgroup label="Pages">';
      foreach ( $pages as $page ){
        $option = '<option value="' . $page->ID .'" ';
        if(in_array($page->ID, $pageTakenIds)){
        	$option .= 'disabled';
        }
        $option .='>';
        $option .= esc_html($page->post_title);
        $option .= '</option>';
        $select .= $option;
      }
      $select .= '</optgroup>';
      $select .= '<optgroup label="Posts">';
      foreach ( $posts as $post ){
        $option = '<option value="' . $post->ID . '">';
        $option .= esc_html(get_the_title( $post->ID ));
        $option .= '</option>';
        $select .= $option;
      }
      $select .= '</optgroup>';
      $select .= '</select>';
      return $select;

    }

}

/**
 * Get all message sounds.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_all_the_sounds')){

  function smwpcb_get_all_the_sounds($input_id,$selected_value){

    $sounds = array("When","Me Too","Clearly","Accomplished","Just Maybe","Unconvinced","Graceful","Hide and seek","No Sound");
    $soundnames = array("when.mp3","me-too.mp3","clearly.mp3","accomplished.mp3","just-maybe.mp3","unconvinced.mp3","graceful.mp3","hide-and-seek.mp3","no-sound.mp3");


    $select = '<select id="'. $input_id .'" required>';

    foreach ( $sounds as $key => $sound ){
      $selected = '';
      if( $selected_value === $soundnames[$key] ){
        $selected = ' selected="selected" ';
      }
      $option = '<option value="' . $soundnames[$key] . '" '.$selected.'>';
      $option .= $sound; 
      $option .= '</option>';
      $select .= $option;
    }
    $select .= '</select>'; 
    $select .= '<span class="dashicons dashicons-controls-volumeon" style="margin-left: 10px;cursor: pointer;
    color: #007cba;font-size: 24px;padding: 2px;" id="smwpcb_ringtone_listen"></span>';
    return $select;

  }

}

/**
 * Load plugin languages.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_load_languages')){

    function smwpcb_load_languages() {

      load_plugin_textdomain( 'smart-wordpress-chatbot', false, SMWPCB_PLUGIN_BASENAME . '/languages/' );
      
    }

}


/**
 * Load plugin languages.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_rate_the_plugin')){

    function smwpcb_rate_the_plugin() {
      $smwpcb_maxbot_additional_settings = get_option('smwpcb_maxbot_additional_settings');
      if($smwpcb_maxbot_additional_settings['smwpcb_user_rating'] == '' || $smwpcb_maxbot_additional_settings['smwpcb_user_rating'] == 'remindme'){
        $filename = SMWPCB_PLUGIN_DIR . 'maxbot-chatbot-maker.php';
        if (file_exists($filename)) {
            $date = strtotime(date ("F d Y H:i:s.", filemtime($filename)));
            $date = strtotime("+7 day", $date);
            if($smwpcb_maxbot_additional_settings['smwpcb_user_rating'] == 'remindme'){
              $date = strtotime("+2 day", $date);
            }
            $installationplus = date('F d Y H:i:s.', $date);
            if($installationplus < date("F d Y H:i:s.")){
              return "<div class='notice notice-info'><p>Awesome! It's been a week now since you've been using Maxbot, please help the development of this plugin by giving it 5 stars on codecanyon. <a id='smwpcb_good_rate' href='https://codecanyon.net/downloads' target='_blank'>Sure!</a> <a href='javascript:void(0)' id='smwpcb_not_good_enough_rate'>Not good enough</a> <a href='javascript:void(0)' id='smwpcb_remind_me_later'>Remind me later</a></p></div>";
            }
            return '';
        }
        return '';
      }
      return '';
      
    }

}


?>