<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Add javacript files and css stylesheets on the admin end.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_add_admin_scripts')){

    function smwpcb_add_admin_scripts(){

      $smwpcb_pages = array("smwpcb_wp_chatbot_code_licence","smwpcb_wp_chatbot_general_settings", "smwpcb_wp_chatbot_agents", "smwpcb_wp_chatbot_data_tables", "smwpcb_wp_users_data","smwpcb_wp_design_chatbot_ui","smwpcb_wp_chatbot_topics","smwpcb_wp_chatbot_projects");
      if(isset($_GET["page"])){
        if (in_array($_GET["page"], $smwpcb_pages) && !isset($_GET["action"])){
            wp_register_style( "smwpcb-custom-wp-admin-css", SMWPCB_PLUGIN_URL_DIR . "admin/css/styleadminoptions.css");
            wp_enqueue_style( "smwpcb-custom-wp-admin-css" );
            wp_register_script( "smwpcb-custom-ui-wp-script", SMWPCB_PLUGIN_URL_DIR . "admin/js/custom-ui-wp.js", array("jquery"), "",true );
            wp_localize_script("smwpcb-custom-ui-wp-script", "smwpcb_custom_ui_wp_link", array(
                "ajax_url" => admin_url("admin-ajax.php"),
                "brain_path" => SMWPCB_PLUGIN_URL_DIR . "/brain",
                "css_path" => SMWPCB_PLUGIN_URL_DIR . "/css",
                "image_path" => SMWPCB_PLUGIN_URL_DIR . "/admin/images",
                "audio_path" => SMWPCB_PLUGIN_URL_DIR . "public/audio"
                ));
            wp_enqueue_script( "smwpcb-custom-ui-wp-script" );
        }elseif( ($_GET["page"] == "smwpcb_wp_chatbot_topics") && (isset($_GET["action"]) && $_GET["action"] == "edit")){
            wp_register_script( "smwpcb-easy-responsive-tags", SMWPCB_PLUGIN_URL_DIR . "libs/easy-responsive-tabs/easyResponsiveTabs.js", array("jquery"), "",true );
            wp_enqueue_script( "smwpcb-easy-responsive-tags" );
            wp_register_script( "smwpcb-bootstrap-suggest-js", SMWPCB_PLUGIN_URL_DIR . "libs/bootstrap-suggest/js/bootstrap-suggest.js", array("jquery"), "",true );
            wp_enqueue_script( "smwpcb-bootstrap-suggest-js" );
            wp_register_script( "smwpcb-bootstrap-tagsinput-js", SMWPCB_PLUGIN_URL_DIR . "libs/bootstrap-tagsinput/js/bootstrap-tagsinput.js", array("jquery"), "",true );
            wp_enqueue_script( "smwpcb-bootstrap-tagsinput-js" );
            wp_register_script( "smwpcb-custom-ui-topics-script", SMWPCB_PLUGIN_URL_DIR . "admin/js/custom-ui-topics.js", array("jquery"), "",true );
            wp_localize_script("smwpcb-custom-ui-topics-script", "smwpcb_custom_ui_topics_link", array(
                "ajax_url" => admin_url("admin-ajax.php"),
                "brain_path" => SMWPCB_PLUGIN_URL_DIR . "/brain",
                "css_path" => SMWPCB_PLUGIN_URL_DIR . "/css",
                "image_path" => SMWPCB_PLUGIN_URL_DIR . "/admin/images"
                ));
            wp_enqueue_script( "smwpcb-custom-ui-topics-script" );
            wp_register_style( 'smwpcb-wp-bootstrap-css', SMWPCB_PLUGIN_URL_DIR . "libs/bootstrap/bootstrap.min.css");
            wp_enqueue_style( 'smwpcb-wp-bootstrap-css' );
            wp_register_style( 'smwpcb-wp-jquery-ui-css', SMWPCB_PLUGIN_URL_DIR . "libs/jquery-ui/jquery-ui.css");
            wp_enqueue_style( 'smwpcb-wp-jquery-ui-css' );
            wp_register_style( 'smwpcb-wp-admin-stories-css', SMWPCB_PLUGIN_URL_DIR . 'admin/css/style.css');
            wp_enqueue_style( 'smwpcb-wp-admin-stories-css' );
            wp_register_style( "smwpcb-bootstrap-suggest-css", SMWPCB_PLUGIN_URL_DIR . "libs/bootstrap-suggest/css/bootstrap-suggest.css");
            wp_enqueue_style( "smwpcb-bootstrap-suggest-css" );
            wp_register_style( 'smwpcb-wp-font-awesome-css', "https://use.fontawesome.com/releases/v5.7.2/css/all.css");
            wp_enqueue_style( 'smwpcb-wp-font-awesome-css' );
            wp_register_style( 'smwpcb-wp-bootstrap-tagsinput-css', SMWPCB_PLUGIN_URL_DIR . 'libs/bootstrap-tagsinput/css/bootstrap-tagsinput.css');
            wp_enqueue_style( 'smwpcb-wp-bootstrap-tagsinput-css' );
        }
      }

    }

}

/**
 * Add javacript files and css stylesheets on the front end.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_add_main_scripts')){

    function smwpcb_add_main_scripts(){
    	
      wp_deregister_script('wp-polyfill');
      wp_register_script( 'smwpcb-rivescript-lib', 'https://unpkg.com/rivescript@2.0.0/dist/rivescript.min.js', array(), '',true );
      wp_enqueue_script( 'smwpcb-rivescript-lib' );
      wp_register_script( 'smwpcb-main-script', SMWPCB_PLUGIN_URL_DIR . 'public/js/main.js', array('jquery'), '',true );
      wp_enqueue_script( 'smwpcb-main-script' );
      wp_register_script( 'smwpcb-script-cards', SMWPCB_PLUGIN_URL_DIR . 'public/js/cards.js', array('jquery'), '',true );
      wp_enqueue_script( 'smwpcb-script-cards' );
      wp_localize_script('smwpcb-main-script', 'smwpcb_main_script_link', array(
        "ajax_url" => admin_url("admin-ajax.php"),
        "brain_path" => SMWPCB_PLUGIN_URL_DIR . 'brain',
        "css_path" => SMWPCB_PLUGIN_URL_DIR . 'css',
        "audio_path" => SMWPCB_PLUGIN_URL_DIR . "public/audio",
        "image_path" => SMWPCB_PLUGIN_URL_DIR . "admin/images",
        "smwpcb_message_sound" => (isset($smwpcb_cb_ui_custom_settings['smwpcb_message_sound']) ? $smwpcb_cb_ui_custom_settings['smwpcb_message_sound'] : 'when.mp3')
      ));
      wp_enqueue_script( 'smwpcb-main-script' );

    }

}

/**
 * Load this fundamental file before the others on the front end.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_main_array_vars')){

    function smwpcb_main_array_vars() {
      $smwpcb_cb_ui_custom_settings = get_option('smwpcb_cb_ui_custom_settings');
      wp_enqueue_script( 'smwpcb-main-vars', SMWPCB_PLUGIN_URL_DIR . 'admin/js/main-vars.js', array( 'jquery' ) );
      wp_localize_script('smwpcb-main-vars', 'smwpcb_main_vars_link', array(
        "ajax_url" => admin_url("admin-ajax.php"),
        "brain_path" => SMWPCB_PLUGIN_URL_DIR . 'brain',
        "css_path" => SMWPCB_PLUGIN_URL_DIR . 'css',
        "audio_path" => SMWPCB_PLUGIN_URL_DIR . "public/audio",
        "image_path" => SMWPCB_PLUGIN_URL_DIR . "admin/images",
        "smwpcb_chatbots_general_settings" => get_option('smwpcb_chatbots_general_settings'),
        "smwpcb_data_tables_settings" => get_option('smwpcb_data_tables_settings'),
        "smwpcb_wp_chatbot_agents" => get_option('smwpcb_wp_chatbot_agents_settings'),
        "smwpcb_unsetted_response_triggers" => get_option('smwpcb_unsetted_response_triggers'),
        "smwpcb_wp_chatbot_topics_settings" => get_option('smwpcb_wp_chatbot_topics_settings'),
        "restoredvars" => json_encode(smwpcb_users_restored_vars()),
        "smwpcb_message_sound" => (isset($smwpcb_cb_ui_custom_settings['smwpcb_message_sound']) ? $smwpcb_cb_ui_custom_settings['smwpcb_message_sound'] : 'when.mp3')
      ));

    }

}

/**
 * Load this fundamental file before the others on the front end.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_main_array_vars_admin')){

    function smwpcb_main_array_vars_admin() {
      $smwpcb_pages = array("smwpcb_wp_chatbot_code_licence","smwpcb_wp_chatbot_general_settings", "smwpcb_wp_chatbot_agents", "smwpcb_wp_chatbot_data_tables", "smwpcb_wp_users_data","smwpcb_wp_design_chatbot_ui","smwpcb_wp_chatbot_topics","smwpcb_wp_chatbot_projects");
      if(isset($_GET["page"])){
        if(in_array($_GET["page"], $smwpcb_pages)){
          $smwpcb_cb_ui_custom_settings = get_option('smwpcb_cb_ui_custom_settings');
          wp_enqueue_script( 'smwpcb-main-vars', SMWPCB_PLUGIN_URL_DIR . 'admin/js/main-vars.js', array( 'jquery' ) );
          wp_localize_script('smwpcb-main-vars', 'smwpcb_main_vars_link', array(
            "ajax_url" => admin_url("admin-ajax.php"),
            "brain_path" => SMWPCB_PLUGIN_URL_DIR . 'brain',
            "css_path" => SMWPCB_PLUGIN_URL_DIR . 'css',
            "audio_path" => SMWPCB_PLUGIN_URL_DIR . "public/audio",
            "image_path" => SMWPCB_PLUGIN_URL_DIR . "admin/images",
            "smwpcb_chatbots_general_settings" => get_option('smwpcb_chatbots_general_settings'),
            "smwpcb_data_tables_settings" => get_option('smwpcb_data_tables_settings'),
            "smwpcb_wp_chatbot_agents" => get_option('smwpcb_wp_chatbot_agents_settings'),
            "smwpcb_unsetted_response_triggers" => get_option('smwpcb_unsetted_response_triggers'),
            "smwpcb_wp_chatbot_topics_settings" => get_option('smwpcb_wp_chatbot_topics_settings'),
            "restoredvars" => json_encode(smwpcb_users_restored_vars()),
            "smwpcb_message_sound" => (isset($smwpcb_cb_ui_custom_settings['smwpcb_message_sound']) ? $smwpcb_cb_ui_custom_settings['smwpcb_message_sound'] : 'when.mp3')
          ));
        }
      }

    }

}

?>