<?php


/**
 * Plugin Name: Maxbot - Chatbot Builder WordPress Plugin
 * Plugin URI:  https://www.persianscript.ir
 * Description: Maxbot eliminates complexity and helps you to build the best possible messaging experience for your customers. It provide the ability to connect and publish intelligent bots to interact with your users naturally wherever they are.
 * Version: 1.3.1
 * Author: پرشین اسکریپت
 * Author URI:  https://www.persianscript.ir
 * Tested up to: 1.3.1
 * Text Domain: smart-wordpress-chatbot
 * Domain Path: /languages
 **/
 


// If this file is called directly, abort.
if(!defined('WPINC')){ die; }

define( 'SMWPCB_VERSION', '1.0.0' );
define( 'SMWPCB_MINIMUM_WP_VERSION', '1.0.0' );
define( 'SMWPCB_PLUGIN_URL_DIR', plugin_dir_url( __FILE__ ) );
define( 'SMWPCB_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'SMWPCB_PLUGIN_BASENAME', dirname( plugin_basename( __FILE__ ) ) );


try{
	if(is_admin()){
		require_once( SMWPCB_PLUGIN_DIR . 'includes/admin-menu.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/default-settings.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/chatbot-stories.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/general-settings.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/columns-table.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/users-data.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/custom-design-chatbot.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/chatbot-agents.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/chatbot-topics.php' );
		require_once( SMWPCB_PLUGIN_DIR . 'includes/chatbot-projects.php' );
	}
	require_once( SMWPCB_PLUGIN_DIR . 'includes/main-admin-script.php' );
	require_once( SMWPCB_PLUGIN_DIR . 'includes/database-manipulation.php' );
	require_once( SMWPCB_PLUGIN_DIR . 'includes/helper-functions.php' );
	require_once( SMWPCB_PLUGIN_DIR . 'includes/ajax-actions.php' );
	require_once( SMWPCB_PLUGIN_DIR . 'includes/reset-styles.php' );
	require_once( SMWPCB_PLUGIN_DIR . 'includes/chatbot-widget.php' );


	add_filter( 'wp_enqueue_scripts', 'smwpcb_main_array_vars', 0 );
	add_filter( 'admin_enqueue_scripts', 'smwpcb_main_array_vars_admin', 0 );
	add_filter( 'the_content', 'smwpcb_add_widget_cb_project' );

	add_action( 'admin_enqueue_scripts', 'smwpcb_add_admin_scripts' );
	add_action( 'wp_enqueue_scripts', 'smwpcb_add_main_scripts' );
	add_action( 'admin_menu', 'smwpcb_admin_menus');
	add_action( 'admin_init', 'smwpcb_init_admin_options');
	add_action( 'wp_ajax_smwpcb_retreive_all_subtopics', 'smwpcb_retreive_all_subtopics' );
	add_action( 'wp_ajax_smwpcb_add_new_data_table_action', 'smwpcb_add_new_data_table_action' );
	add_action( 'wp_ajax_smwpcb_save_data_user_action', 'smwpcb_save_data_user_action' );
	add_action( 'wp_ajax_smwpcb_delete_data_user_action', 'smwpcb_delete_data_user_action' );
	add_action( 'wp_ajax_smwpcb_get_updated_project', 'smwpcb_get_updated_project' );
	add_action( 'wp_ajax_smwpcb_get_updated_column', 'smwpcb_get_updated_column' );
	add_action( 'wp_ajax_nopriv_smwpcb_add_value_users_data_action', 'smwpcb_add_value_users_data_action' );
	add_action( 'wp_ajax_smwpcb_add_value_users_data_action', 'smwpcb_add_value_users_data_action' );
	add_action( 'wp_ajax_nopriv_smwpcb_add_users_response_action', 'smwpcb_add_users_response_action' );
	add_action( 'wp_ajax_smwpcb_add_users_response_action', 'smwpcb_add_users_response_action' );
	add_action( 'wp_ajax_smwpcb_delete_agent_action', 'smwpcb_delete_agent_action' );
	add_action( 'wp_ajax_smwpcb_delete_project_action', 'smwpcb_delete_project_action' );
	add_action( 'wp_ajax_smwpcb_delete_column_action', 'smwpcb_delete_column_action' );
	add_action( 'wp_ajax_smwpcb_delete_topic_action', 'smwpcb_delete_topic_action' );
	add_action( 'wp_ajax_smwpcb_delete_apply_topic_action', 'smwpcb_delete_apply_topic_action' );
	add_action( 'wp_ajax_smwpcb_delete_apply_user_data_action', 'smwpcb_delete_apply_user_data_action' );
	add_action( 'wp_ajax_smwpcb_delete_apply_project_action', 'smwpcb_delete_apply_project_action' );
	add_action( 'wp_ajax_smwpcb_delete_apply_column_table_action', 'smwpcb_delete_apply_column_table_action' );
	add_action( 'wp_ajax_nopriv_smwpcb_add_unsetted_triggers_db', 'smwpcb_add_unsetted_triggers_db' );
	add_action( 'wp_ajax_smwpcb_add_code_licence_action', 'smwpcb_add_code_licence_action' );
	add_action( 'wp_ajax_smwpcb_delete_code_licence_action', 'smwpcb_delete_code_licence_action' );
	add_action( 'wp_ajax_smwpcb_add_unsetted_triggers_db', 'smwpcb_add_unsetted_triggers_db' );
	add_action( 'wp_ajax_smwpcb_remove_unsetted_triggers_db', 'smwpcb_remove_unsetted_triggers_db' );
	add_action( 'wp_ajax_smwpcb_cb_ui_custom_action', 'smwpcb_cb_ui_custom_action' );
	add_action( "admin_init", "smwpcb_download_exported" );
	add_action( 'wp_ajax_smwpcb_generate_file', 'smwpcb_generate_file' );
	add_action( 'wp_ajax_smwpcb_rate_the_plugin_action', 'smwpcb_rate_the_plugin_action' );
	add_action( 'plugins_loaded', 'smwpcb_load_languages');
	add_shortcode( 'maxbot-chatbot-builder', 'smwpcb_return_shortcode_cb_page' );

}catch(Exception $e){
	$message = $e->getMessage();
	echo esc_html_e('Maxbot Chatbot Builder Error:', 'smart-wordpress-chatbot').' <b>'. esc_html($message) .'</b>';
}

